/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: FXRbDC.h,v 1.2 2002/01/02 22:23:55 ljohnson Exp $
 ***********************************************************************/

#ifndef FXRBDC_H
#define FXRBDC_H

#define IMPLEMENT_FXDC_STUBS(cls,baseclass) \
  FXColor cls::_readPixel(FXint x,FXint y){ \
    return baseclass::readPixel(x,y); \
    } \
  FXColor cls::readPixel(FXint x,FXint y){ \
    return FXRbCallColorMethod(this,"readPixel",x,y); \
    } \
  void cls::_drawPoint(FXint x,FXint y){ \
    baseclass::drawPoint(x,y); \
    } \
  void cls::drawPoint(FXint x,FXint y){ \
    FXRbCallVoidMethod(this,"drawPoint",x,y); \
    } \
  void cls::_drawPoints(const FXPoint* points,FXuint npoints){ \
    baseclass::drawPoints(points,npoints); \
    } \
  void cls::drawPoints(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"drawPoints",points,npoints); \
    } \
  void cls::_drawPointsRel(const FXPoint* points,FXuint npoints){ \
    baseclass::drawPointsRel(points,npoints); \
    } \
  void cls::drawPointsRel(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"drawPointsRel",points,npoints); \
    } \
  void cls::_drawLine(FXint x1,FXint y1,FXint x2,FXint y2){ \
    baseclass::drawLine(x1,y1,x2,y2); \
    } \
  void cls::drawLine(FXint x1,FXint y1,FXint x2,FXint y2){ \
    FXRbCallVoidMethod(this,"drawLine",x1,y1,x2,y2); \
    } \
  void cls::_drawLines(const FXPoint* points,FXuint npoints){ \
    baseclass::drawLines(points,npoints); \
    } \
  void cls::drawLines(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"drawLines",points,npoints); \
    } \
  void cls::_drawLinesRel(const FXPoint* points,FXuint npoints){ \
    baseclass::drawLinesRel(points,npoints); \
    } \
  void cls::drawLinesRel(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"drawLinesRel",points,npoints); \
    } \
  void cls::_drawLineSegments(const FXSegment* segments,FXuint nsegments){ \
    baseclass::drawLineSegments(segments,nsegments); \
    } \
  void cls::drawLineSegments(const FXSegment* segments,FXuint nsegments){ \
    FXRbCallVoidMethod(this,"drawLineSegments",segments,nsegments); \
    } \
  void cls::_drawRectangle(FXint x,FXint y,FXint w,FXint h){ \
    baseclass::drawRectangle(x,y,w,h); \
    } \
  void cls::drawRectangle(FXint x,FXint y,FXint w,FXint h){ \
    FXRbCallVoidMethod(this,"drawRectangle",x,y,w,h); \
    } \
  void cls::_drawRectangles(const FXRectangle* rectangles,FXuint nrectangles){ \
    baseclass::drawRectangles(rectangles,nrectangles); \
    } \
  void cls::drawRectangles(const FXRectangle* rectangles,FXuint nrectangles){ \
    FXRbCallVoidMethod(this,"drawRectangles",rectangles,nrectangles); \
    } \
  void cls::_drawArc(FXint x,FXint y,FXint w,FXint h,FXint ang1,FXint ang2){ \
    baseclass::drawArc(x,y,w,h,ang1,ang2); \
    } \
  void cls::drawArc(FXint x,FXint y,FXint w,FXint h,FXint ang1,FXint ang2){ \
    FXRbCallVoidMethod(this,"drawArc",x,y,w,h,ang1,ang2); \
    } \
  void cls::_drawArcs(const FXArc* arcs,FXuint narcs){ \
    baseclass::drawArcs(arcs,narcs); \
    } \
  void cls::drawArcs(const FXArc* arcs,FXuint narcs){ \
    FXRbCallVoidMethod(this,"drawArcs",arcs,narcs); \
    } \
  void cls::_fillRectangle(FXint x,FXint y,FXint w,FXint h){ \
    baseclass::fillRectangle(x,y,w,h); \
    } \
  void cls::fillRectangle(FXint x,FXint y,FXint w,FXint h){ \
    FXRbCallVoidMethod(this,"fillRectangle",x,y,w,h); \
    } \
  void cls::_fillRectangles(const FXRectangle* rectangles,FXuint nrectangles){ \
    baseclass::fillRectangles(rectangles,nrectangles); \
    } \
  void cls::fillRectangles(const FXRectangle* rectangles,FXuint nrectangles){ \
    FXRbCallVoidMethod(this,"fillRectangles",rectangles,nrectangles); \
    } \
  void cls::_fillArc(FXint x,FXint y,FXint w,FXint h,FXint ang1,FXint ang2){ \
    baseclass::fillArc(x,y,w,h,ang1,ang2); \
    } \
  void cls::fillArc(FXint x,FXint y,FXint w,FXint h,FXint ang1,FXint ang2){ \
    FXRbCallVoidMethod(this,"fillArc",x,y,w,h,ang1,ang2); \
    } \
  void cls::_fillArcs(const FXArc* arcs,FXuint narcs){ \
    baseclass::fillArcs(arcs,narcs); \
    } \
  void cls::fillArcs(const FXArc* arcs,FXuint narcs){ \
    FXRbCallVoidMethod(this,"fillArcs",arcs,narcs); \
    } \
  void cls::_fillPolygon(const FXPoint* points,FXuint npoints){ \
    baseclass::fillPolygon(points,npoints); \
    } \
  void cls::fillPolygon(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillPolygon",points,npoints); \
    } \
  void cls::_fillConcavePolygon(const FXPoint* points,FXuint npoints){ \
    baseclass::fillConcavePolygon(points,npoints); \
    } \
  void cls::fillConcavePolygon(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillConcavePolygon",points,npoints); \
    } \
  void cls::_fillComplexPolygon(const FXPoint* points,FXuint npoints){ \
    baseclass::fillComplexPolygon(points,npoints); \
    } \
  void cls::fillComplexPolygon(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillComplexPolygon",points,npoints); \
    } \
  void cls::_fillPolygonRel(const FXPoint* points,FXuint npoints){ \
    baseclass::fillPolygonRel(points,npoints); \
    } \
  void cls::fillPolygonRel(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillPolygonRel",points,npoints); \
    } \
  void cls::_fillConcavePolygonRel(const FXPoint* points,FXuint npoints){ \
    baseclass::fillConcavePolygonRel(points,npoints); \
    } \
  void cls::fillConcavePolygonRel(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillConcavePolygonRel",points,npoints); \
    } \
  void cls::_fillComplexPolygonRel(const FXPoint* points,FXuint npoints){ \
    baseclass::fillComplexPolygonRel(points,npoints); \
    } \
  void cls::fillComplexPolygonRel(const FXPoint* points,FXuint npoints){ \
    FXRbCallVoidMethod(this,"fillComplexPolygonRel",points,npoints); \
    } \
  void cls::_drawHashBox(FXint x,FXint y,FXint w,FXint h,FXint b){ \
    baseclass::drawHashBox(x,y,w,h,b); \
    } \
  void cls::drawHashBox(FXint x,FXint y,FXint w,FXint h,FXint b){ \
    FXRbCallVoidMethod(this,"drawHashBox",x,y,w,h,b); \
    } \
  void cls::_drawFocusRectangle(FXint x,FXint y,FXint w,FXint h){ \
    baseclass::drawFocusRectangle(x,y,w,h); \
    } \
  void cls::drawFocusRectangle(FXint x,FXint y,FXint w,FXint h){ \
    FXRbCallVoidMethod(this,"drawFocusRectangle",x,y,w,h); \
    } \
  void cls::_drawArea(const FXDrawable* source,FXint sx,FXint sy,FXint sw,FXint sh,FXint dx,FXint dy){ \
    baseclass::drawArea(source,sx,sy,sw,sh,dx,dy); \
    } \
  void cls::drawArea(const FXDrawable* source,FXint sx,FXint sy,FXint sw,FXint sh,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawArea",source,sx,sy,sw,sh,dx,dy); \
    } \
  void cls::_drawImage(const FXImage* image,FXint dx,FXint dy){ \
    baseclass::drawImage(image,dx,dy); \
    } \
  void cls::drawImage(const FXImage* image,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawImage",image,dx,dy); \
    } \
  void cls::_drawBitmap(const FXBitmap* bitmap,FXint dx,FXint dy){ \
    baseclass::drawBitmap(bitmap,dx,dy); \
    } \
  void cls::drawBitmap(const FXBitmap* bitmap,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawBitmap",bitmap,dx,dy); \
    } \
  void cls::_drawIcon(const FXIcon* icon,FXint dx,FXint dy){ \
    baseclass::drawIcon(icon,dx,dy); \
    } \
  void cls::drawIcon(const FXIcon* icon,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawIcon",icon,dx,dy); \
    } \
  void cls::_drawIconShaded(const FXIcon* icon,FXint dx,FXint dy){ \
    baseclass::drawIconShaded(icon,dx,dy); \
    } \
  void cls::drawIconShaded(const FXIcon* icon,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawIconShaded",icon,dx,dy); \
    } \
  void cls::_drawIconSunken(const FXIcon* icon,FXint dx,FXint dy){ \
    baseclass::drawIconSunken(icon,dx,dy); \
    } \
  void cls::drawIconSunken(const FXIcon* icon,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"drawIconSunken",icon,dx,dy); \
    } \
  void cls::_drawText(FXint x,FXint y,const FXchar* string,FXuint length){ \
    baseclass::drawText(x,y,string,length); \
    } \
  void cls::drawText(FXint x,FXint y,const FXchar* string,FXuint length){ \
    FXRbCallVoidMethod(this,"drawText",x,y,string,length); \
    } \
  void cls::_drawImageText(FXint x,FXint y,const FXchar* string,FXuint length){ \
    baseclass::drawImageText(x,y,string,length); \
    } \
  void cls::drawImageText(FXint x,FXint y,const FXchar* string,FXuint length){ \
    FXRbCallVoidMethod(this,"drawImageText",x,y,string,length); \
    } \
  void cls::_setForeground(FXColor clr){ \
    baseclass::setForeground(clr); \
    } \
  void cls::setForeground(FXColor clr){ \
    FXRbCallVoidMethod(this,"setForeground",clr); \
    } \
  void cls::_setBackground(FXColor clr){ \
    baseclass::setBackground(clr); \
    } \
  void cls::setBackground(FXColor clr){ \
    FXRbCallVoidMethod(this,"setBackground",clr); \
    } \
  void cls::_setDashes(FXuint dashoffset,const FXchar *dashlist,FXuint n){ \
    baseclass::setDashes(dashoffset,dashlist,n); \
    } \
  void cls::setDashes(FXuint dashoffset,const FXchar *dashlist,FXuint n){ \
    FXRbCallVoidMethod(this,"setDashes",dashoffset,dashlist,n); \
    } \
  void cls::_setLineWidth(FXuint linewidth){ \
    baseclass::setLineWidth(linewidth); \
    } \
  void cls::setLineWidth(FXuint linewidth){ \
    FXRbCallVoidMethod(this,"setLineWidth",linewidth); \
    } \
  void cls::_setLineCap(FXCapStyle capstyle){ \
    baseclass::setLineCap(capstyle); \
    } \
  void cls::setLineCap(FXCapStyle capstyle){ \
    FXRbCallVoidMethod(this,"setLineCap",capstyle); \
    } \
  void cls::_setLineJoin(FXJoinStyle joinstyle){ \
    baseclass::setLineJoin(joinstyle); \
    } \
  void cls::setLineJoin(FXJoinStyle joinstyle){ \
    FXRbCallVoidMethod(this,"setLineJoin",joinstyle); \
    } \
  void cls::_setLineStyle(FXLineStyle linestyle){ \
    baseclass::setLineStyle(linestyle); \
    } \
  void cls::setLineStyle(FXLineStyle linestyle){ \
    FXRbCallVoidMethod(this,"setLineStyle",linestyle); \
    } \
  void cls::_setFillStyle(FXFillStyle fillstyle){ \
    baseclass::setFillStyle(fillstyle); \
    } \
  void cls::setFillStyle(FXFillStyle fillstyle){ \
    FXRbCallVoidMethod(this,"setFillStyle",fillstyle); \
    } \
  void cls::_setFillRule(FXFillRule fillrule){ \
    baseclass::setFillRule(fillrule); \
    } \
  void cls::setFillRule(FXFillRule fillrule){ \
    FXRbCallVoidMethod(this,"setFillRule",fillrule); \
    } \
  void cls::_setFunction(FXFunction func){ \
    baseclass::setFunction(func); \
    } \
  void cls::setFunction(FXFunction func){ \
    FXRbCallVoidMethod(this,"setFunction",func); \
    } \
  void cls::_setTile(FXImage* image,FXint dx,FXint dy){ \
    baseclass::setTile(image,dx,dy); \
    } \
  void cls::setTile(FXImage* image,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"setTile",image,dx,dy); \
    } \
  void cls::_setStipple(FXBitmap *bitmap,FXint dx,FXint dy){ \
    baseclass::setStipple(bitmap,dx,dy); \
    } \
  void cls::setStipple(FXBitmap *bitmap,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"setStipple",bitmap,dx,dy); \
    } \
  void cls::_setStipple(FXStipplePattern pat,FXint dx,FXint dy){ \
    baseclass::setStipple(pat,dx,dy); \
    } \
  void cls::setStipple(FXStipplePattern pat,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"setStipple",pat,dx,dy); \
    } \
  void cls::_setClipRegion(const FXRegion& region){ \
    baseclass::setClipRegion(region); \
    } \
  void cls::setClipRegion(const FXRegion& region){ \
    FXRbCallVoidMethod(this,"setClipRegion",region); \
    } \
  void cls::_setClipRectangle(FXint x,FXint y,FXint w,FXint h){ \
    baseclass::setClipRectangle(x,y,w,h); \
    } \
  void cls::setClipRectangle(FXint x,FXint y,FXint w,FXint h){ \
    FXRbCallVoidMethod(this,"setClipRectangle",x,y,w,h); \
    } \
  void cls::_setClipRectangle(const FXRectangle& rectangle){ \
    baseclass::setClipRectangle(rectangle); \
    } \
  void cls::setClipRectangle(const FXRectangle& rectangle){ \
    FXRbCallVoidMethod(this,"setClipRectangle",rectangle); \
    } \
  void cls::_clearClipRectangle(){ \
    baseclass::clearClipRectangle(); \
    } \
  void cls::clearClipRectangle(){ \
    FXRbCallVoidMethod(this,"clearClipRectangle"); \
    } \
  void cls::_setClipMask(FXBitmap* bitmap,FXint dx,FXint dy){ \
    baseclass::setClipMask(bitmap,dx,dy); \
    } \
  void cls::setClipMask(FXBitmap* bitmap,FXint dx,FXint dy){ \
    FXRbCallVoidMethod(this,"setClipMask",bitmap,dx,dy); \
    } \
  void cls::_clearClipMask(){ \
    baseclass::clearClipMask(); \
    } \
  void cls::clearClipMask(){ \
    FXRbCallVoidMethod(this,"clearClipMask"); \
    } \
  void cls::_setTextFont(FXFont *fnt){ \
    baseclass::setTextFont(fnt); \
    } \
  void cls::setTextFont(FXFont *fnt){ \
    FXRbCallVoidMethod(this,"setTextFont",fnt); \
    } \
  void cls::_clipChildren(FXbool yes){ \
    baseclass::clipChildren(yes); \
    } \
  void cls::clipChildren(FXbool yes){ \
    FXRbCallVoidMethod(this,"clipChildren",yes); \
    }


class FXRbDC : public FXDC {
#include "FXRbDCVirtuals.h"
public:
  // Constructor
  FXRbDC(FXApp* app) : FXDC(app){}

  // Mark dependencies for the GC
  static void markfunc(FXDC* self);

  // Destructor
  virtual ~FXRbDC(){
    FXRbUnregisterRubyObj(this);
    }
  };

#endif
