/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: FXRbFileDict.h,v 1.2 2001/10/01 19:21:04 ljohnson Exp $
 ***********************************************************************/

#ifndef FXRBFILEDICT_H
#define FXRBFILEDICT_H

/// Icon dictionary
class FXRbIconDict : public FXIconDict {
  FXDECLARE(FXRbIconDict)
#include "FXRbObjectVirtuals.h"
public:
  /// Construct an icon dictionary
  FXRbIconDict(FXApp* a=NULL) : FXIconDict(a){}

  // Mark dependencies for the GC
  static void markfunc(FXIconDict* self);

  // Destructor
  virtual ~FXRbIconDict(){
    FXRbUnregisterRubyObj(this);
    }
  };


#define IMPLEMENT_FXFILEDICT_STUBS(cls,baseclass) \
  FXFileAssoc* cls::_findFileBinding(const FXchar* pathname){ \
    return baseclass::findFileBinding(pathname); \
    } \
  FXFileAssoc* cls::findFileBinding(const FXchar* pathname){ \
    return baseclass::findFileBinding(pathname); \
    } \
  FXFileAssoc* cls::_findDirBinding(const FXchar* pathname){ \
    return baseclass::findDirBinding(pathname); \
    } \
  FXFileAssoc* cls::findDirBinding(const FXchar* pathname){ \
    return baseclass::findDirBinding(pathname); \
    } \
  FXFileAssoc* cls::_findExecBinding(const FXchar* pathname){ \
    return baseclass::findExecBinding(pathname); \
    } \
  FXFileAssoc* cls::findExecBinding(const FXchar* pathname){ \
    return baseclass::findExecBinding(pathname); \
    }

    
/// File Association dictionary
class FXRbFileDict : public FXFileDict {
  FXDECLARE(FXRbFileDict)
#include "FXRbObjectVirtuals.h"
#include "FXRbFileDictVirtuals.h"
public:
  /// Construct an file association table
  FXRbFileDict(FXApp* a=NULL):FXFileDict(a){}

  // Mark dependencies for the GC
  static void markfunc(FXFileDict* self);

  // Destructor
  virtual ~FXRbFileDict(){
    FXRbUnregisterRubyObj(this);
    }
  };
  

#endif
