/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: FXRbGLShape.h,v 1.2 2001/08/08 17:13:43 ljohnson Exp $
 ***********************************************************************/

#ifndef FXRBGLSHAPE_H
#define FXRBGLSHAPE_H

#define IMPLEMENT_FXGLSHAPE_STUBS(cls,baseclass) \
  void cls::_drawshape(FXGLViewer* viewer){ \
    baseclass::drawshape(viewer); \
    } \
  void cls::drawshape(FXGLViewer* viewer){ \
    FXRbCallVoidMethod(this,"drawshape",viewer); \
    }

class FXRbGLShape : public FXGLShape {
  FXDECLARE(FXRbGLShape)
protected:
  FXRbGLShape(){}
#include "FXRbObjectVirtuals.h"
#include "FXRbGLObjectVirtuals.h"
#include "FXRbGLShapeVirtuals.h"
public:
  /// Construct with specified origin and options
  FXRbGLShape(FXfloat x,FXfloat y,FXfloat z,FXuint opts) :
    FXGLShape(x,y,z,opts){}

  /// Construct with specified origin, options and front and back materials
  FXRbGLShape(FXfloat x,FXfloat y,FXfloat z,FXuint opts,const FXMaterial& front,const FXMaterial& back) : FXGLShape(x,y,z,opts,front,back){}

  // Set the range
  void setRange(FXRange& box){
    range=box;
    }

  // Mark dependencies for the GC
  static void markfunc(FXGLShape* self);

  // Destructor
  virtual ~FXRbGLShape(){
    FXRbUnregisterRubyObj(this);
    }
  };

#endif
