/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: FXRbObject.h,v 1.1 2001/07/12 19:44:18 ljohnson Exp $
 ***********************************************************************/

#ifndef FXRBOBJECT_H
#define FXRBOBJECT_H

#define IMPLEMENT_FXOBJECT_STUBS(cls,baseclass) \
  long cls::_onDefault(FXObject* sender,FXSelector sel,void* ptr){ \
    return baseclass::onDefault(sender,sel,ptr); \
    } \
  long cls::onDefault(FXObject* sender,FXSelector sel,void* ptr){ \
    return FXRbCallLongMethod(this,"onDefault",sender,sel,ptr); \
    } \
  void cls::_save(FXStream& store) const { \
    baseclass::save(store); \
    } \
  void cls::save(FXStream& store) const { \
    FXRbCallVoidMethod(this,"save",store); \
    } \
  void cls::_load(FXStream& store){ \
    baseclass::load(store); \
    } \
  void cls::load(FXStream& store){ \
    FXRbCallVoidMethod(this,"load",store); \
    }


class FXRbObject : public FXObject {
  FXDECLARE(FXRbObject)
#include "FXRbObjectVirtuals.h"
public:
  // Constructor
  FXRbObject(){}

  // Mark dependencies for the GC
  static void markfunc(FXObject* obj);

  // Destructor
  virtual ~FXRbObject(){
    FXRbUnregisterRubyObj(this);
    }
  };

#endif
