/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: FXRbScrollArea.h,v 1.1 2001/07/12 19:44:18 ljohnson Exp $
 ***********************************************************************/

#ifndef FXRBSCROLLAREA_H
#define FXRBSCROLLAREA_H

#define IMPLEMENT_FXSCROLLAREA_STUBS(cls,baseclass) \
  FXint cls::_getContentWidth(){ \
    return baseclass::getContentWidth(); \
    } \
  FXint cls::getContentWidth(){ \
    return FXRbCallIntMethod(this,"getContentWidth"); \
    } \
  FXint cls::_getContentHeight(){ \
    return baseclass::getContentHeight(); \
    } \
  FXint cls::getContentHeight(){ \
    return FXRbCallIntMethod(this,"getContentHeight"); \
    } \
  FXint cls::_getViewportWidth(){ \
    return baseclass::getViewportWidth(); \
    } \
  FXint cls::getViewportWidth(){ \
    return FXRbCallIntMethod(this,"getViewportWidth"); \
    } \
  FXint cls::_getViewportHeight(){ \
    return baseclass::getViewportHeight(); \
    } \
  FXint cls::getViewportHeight(){ \
    return FXRbCallIntMethod(this,"getViewportHeight"); \
    } \
  void cls::_moveContents(FXint x,FXint y){ \
    baseclass::moveContents(x,y); \
    } \
  void cls::moveContents(FXint x,FXint y){ \
    FXRbCallVoidMethod(this,"moveContents",x,y); \
    }


class FXRbScrollArea : public FXScrollArea {
  FXDECLARE(FXRbScrollArea)
protected:
  FXRbScrollArea(){}
#include "FXRbObjectVirtuals.h"
#include "FXRbIdVirtuals.h"
#include "FXRbDrawableVirtuals.h"
#include "FXRbWindowVirtuals.h"
#include "FXRbScrollAreaVirtuals.h"
public:
  /// Constructor
  FXRbScrollArea(FXComposite* p,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0) : FXScrollArea(p,opts,x,y,w,h){}

  // Mark dependencies for the GC
  static void markfunc(FXScrollArea* self);

  // Destructor
  virtual ~FXRbScrollArea(){
    FXRbUnregisterRubyObj(this);
    }
  };

#endif
