/***********************************************************************
 * $Id: markfuncs.cpp,v 1.11 2002/01/03 01:12:41 ljohnson Exp $
 ***********************************************************************/

#include "FXRbCommon.h"

// FIXME: How to get to the target objects stored in the accelerator
// table? This is currently private (not protected) data for the class.
void FXRbAccelTable::markfunc(FXAccelTable* accelTable){
  FXTRACE((100,"FXRbAccelTable::markfunc() %p\n",accelTable));
  FXRbObject::markfunc(accelTable);
  }


// Mark dependencies for the GC
void FXRbObject::markfunc(FXObject* obj){
  FXTRACE((100,"FXRbObject::markfunc() %p\n",obj));
  }


void FXRbBMPIcon::markfunc(FXBMPIcon *icon){
  FXTRACE((100,"FXRbBMPIcon::markfunc() %p\n",icon));
  FXRbIcon::markfunc(icon);
  }


void FXRbIcon::markfunc(FXIcon* icon){
  FXTRACE((100,"FXRbIcon::markfunc() %p\n",icon));
  FXRbImage::markfunc(icon);
  }


void FXRbImage::markfunc(FXImage* image){
  FXTRACE((100,"FXRbImage::markfunc() %p\n",image));
  FXRbDrawable::markfunc(image);
  }


void FXRbBMPImage::markfunc(FXBMPImage* image){
  FXTRACE((100,"FXRbBMPImage::markfunc() %p\n",image));
  FXRbImage::markfunc(image);
  }


void FXRbBitmap::markfunc(FXBitmap* bitmap){
  FXTRACE((100,"FXRbBitmap::markfunc() %p\n",bitmap));
  FXRbDrawable::markfunc(bitmap);
  }


void FXRbButton::markfunc(FXButton* btn){
  FXTRACE((100,"FXRbButton::markfunc() %p\n",btn));
  FXRbLabel::markfunc(btn);
  }


void FXRbLabel::markfunc(FXLabel* self){
  FXTRACE((100,"FXRbLabel::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    FXRbGcMark(self->getIcon());
    }
  }


void FXRbFrame::markfunc(FXFrame* frame){
  FXTRACE((100,"FXRbFrame::markfunc() %p\n",frame));
  FXRbWindow::markfunc(frame);
  }


void FXRbDrawable::markfunc(FXDrawable* drawable){
  FXTRACE((100,"FXRbDrawable::markfunc() %p\n",drawable));
  FXRbId::markfunc(drawable);
  if(drawable) FXRbGcMark(drawable->getVisual());
  }


void FXRbId::markfunc(FXId* self){
  FXTRACE((100,"FXRbId::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getApp());
    if(self->getUserData()) rb_gc_mark((VALUE) self->getUserData());
    }
  }


void FXRbCanvas::markfunc(FXCanvas* canvas){
  FXTRACE((100,"FXRbCanvas::markfunc() %p\n",canvas));
  FXRbWindow::markfunc(canvas);
  }


void FXRbCheckButton::markfunc(FXCheckButton* cb){
  FXTRACE((100,"FXRbCheckButton::markfunc() %p\n",cb));
  FXRbLabel::markfunc(cb);
  }


void FXRbColorDialog::markfunc(FXColorDialog* dlg){
  FXTRACE((100,"FXRbColorDialog::markfunc() %p\n",dlg));
  FXRbDialogBox::markfunc(dlg);
  }


void FXRbWindow::markfunc(FXWindow* self){
  FXTRACE((100,"FXRbWindow::markfunc() %p\n",self));
  FXRbDrawable::markfunc(self);
  if(self){
    FXRbGcMark(self->getParent());
    FXRbGcMark(self->getOwner());
    FXRbGcMark(self->getShell());
    FXRbGcMark(self->getRoot());
    // FXRbGcMark(self->getNext());
    // FXRbGcMark(self->getPrev());
    FXRbGcMark(self->getFocus());
    FXRbGcMark(self->getTarget());
    FXRbGcMark(self->getAccelTable());
    FXRbGcMark(self->getDefaultCursor());
    FXRbGcMark(self->getDragCursor());

    // Mark child windows
    register FXWindow* child=self->getFirst();
    while(child!=NULL){
      FXRbGcMark(child);
      child=child->getNext();
      }
    }
  }


void FXRbDialogBox::markfunc(FXDialogBox* dlg){
  FXTRACE((100,"FXRbDialogBox::markfunc() %p\n",dlg));
  FXRbTopWindow::markfunc(dlg);
  }


void FXRbTopWindow::markfunc(FXTopWindow* top){
  FXTRACE((100,"FXRbTopWindow::markfunc() %p\n",top));
  FXRbShell::markfunc(top);
  if(top){
    FXRbGcMark(top->getIcon());
    FXRbGcMark(top->getMiniIcon());
    }
  }


void FXRbShell::markfunc(FXShell* shell){
  FXTRACE((100,"FXRbShell::markfunc() %p\n",shell));
  FXRbComposite::markfunc(shell);
  }


void FXRbComposite::markfunc(FXComposite* c){
  FXTRACE((100,"FXRbComposite::markfunc() %p\n",c));
  FXRbWindow::markfunc(c);
  }


void FXRbColorSelector::markfunc(FXColorSelector* cs){
  FXTRACE((100,"FXRbColorSelector::markfunc() %p\n",cs));
  FXRbPacker::markfunc(cs);
  }


void FXRbPacker::markfunc(FXPacker* packer){
  FXTRACE((100,"FXRbPacker::markfunc() %p\n",packer));
  FXRbComposite::markfunc(packer);
  }


void FXRbHorizontalFrame::markfunc(FXHorizontalFrame* self){
  FXTRACE((100,"FXRbHorizontalFrame::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbVerticalFrame::markfunc(FXVerticalFrame* self){
  FXTRACE((100,"FXRbVerticalFrame::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbGroupBox::markfunc(FXGroupBox* self){
  FXTRACE((100,"FXRbGroupBox::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbColorWell::markfunc(FXColorWell* cw){
  FXTRACE((100,"FXRbColorWell::markfunc() %p\n",cw));
  FXRbFrame::markfunc(cw);
  }


void FXRbComboBox::markfunc(FXComboBox* self){
  FXTRACE((100,"FXRbComboBox::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    for(FXint i=0; i<self->getNumItems(); i++){
      if(self->getItemData(i))
        rb_gc_mark((VALUE) self->getItemData(i));
      }
    }
  }


void FXRbCursor::markfunc(FXCursor* cursor){
  FXTRACE((100,"FXRbCursor::markfunc() %p\n",cursor));
  FXRbId::markfunc(cursor);
  }


void FXRbApp::markfunc(FXApp *self){
  FXTRACE((100,"%s::markfunc() %p\n",self));
  FXRbObject::markfunc(self);

  if(self){
    // Visuals
    FXRbGcMark(self->getMonoVisual());
    FXRbGcMark(self->getDefaultVisual());

    // Fonts
    FXRbGcMark(self->getNormalFont());

    // Cursors
    FXRbGcMark(self->getWaitCursor());
    FXRbGcMark(self->getDefaultCursor(DEF_ARROW_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_RARROW_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_TEXT_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_HSPLIT_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_VSPLIT_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_XSPLIT_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_SWATCH_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_MOVE_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGH_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGV_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGTL_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGBR_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGTR_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DRAGBL_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DNDSTOP_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DNDCOPY_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DNDMOVE_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_DNDLINK_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_CROSSHAIR_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_CORNERNE_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_CORNERNW_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_CORNERSE_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_CORNERSW_CURSOR));
    FXRbGcMark(self->getDefaultCursor(DEF_ROTATE_CURSOR));
  
    // Other windows
    FXRbGcMark(self->getMainWindow());
    FXRbGcMark(self->getFocusWindow());
    FXRbGcMark(self->getCursorWindow());
  
    /**
     * Root window is a special case; popups (like FXTooltip) can be created
     * without an "owner" by passing FXApp as the first argument to their
     * constructor, but in fact the "owner" of these window is the root window.
     * So unless we invoke FXRbRootWindow's mark function here, unowned windows
     * like tooltips may get garbage-collected prematurely.
     */
    if(self->getRoot()){
      FXRbGcMark(self->getRoot());
      FXRbRootWindow::markfunc(self->getRoot());
      }
  
    // Timers, chores and signals are recycled and should never be destroyed
    }
  }


void FXRbArrowButton::markfunc(FXArrowButton *btn){
  FXTRACE((100,"FXRbArrowButton::markfunc() %p\n",btn));
  FXRbFrame::markfunc(btn);
  }


void FXRbDataTarget::markfunc(FXDataTarget* obj){
  FXTRACE((100,"FXRbDataTarget::markfunc() %p\n",obj));
  FXRbObject::markfunc(obj);
  }


void FXRbMainWindow::markfunc(FXMainWindow* obj){
  FXTRACE((100,"FXRbMainWindow::markfunc() %p\n",obj));
  FXRbTopWindow::markfunc(obj);
  }


void FXRbTreeItem::markfunc(FXTreeItem* self){
  FXTRACE((100,"FXRbTreeItem::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getParent());
    FXRbGcMark(self->getNext());
    FXRbGcMark(self->getPrev());
    for(FXTreeItem* item=self->getFirst(); item; item=item->getNext()){
      FXRbGcMark(item);
      FXRbTreeItem::markfunc(item);
      }
    FXRbGcMark(self->getBelow());
    FXRbGcMark(self->getAbove());
    FXRbGcMark(self->getOpenIcon());
    FXRbGcMark(self->getClosedIcon());
    if(self->getData())
      rb_gc_mark((VALUE) self->getData());
    }
  }


void FXRbTreeItem::freefunc(FXRbTreeItem* self){
  FXTRACE((100,"FXRbTreeItem::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbTreeList::markfunc(FXTreeList* self){
  FXTRACE((100,"FXRbTreeList::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    for(FXTreeItem* item=self->getFirstItem(); item; item=item->getNext()){
      FXRbGcMark(item);
      FXRbTreeItem::markfunc(item);
      }
    FXRbGcMark(self->getFont());
    }
  }


void FXRbListItem::markfunc(FXListItem* self){
  FXTRACE((100,"FXRbListItem::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getIcon());
    if(self->getData())
      rb_gc_mark((VALUE) self->getData());
    }
  }


void FXRbListItem::freefunc(FXRbListItem* self){
  FXTRACE((100,"FXRbListItem::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbList::markfunc(FXList* self){
  FXTRACE((100,"FXRbList::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    for(FXint i=0;i<self->getNumItems();i++){
      FXListItem* item=self->retrieveItem(i);
      FXRbGcMark(item);
      FXRbListItem::markfunc(item);
      if(self->getItemData(i))
        rb_gc_mark((VALUE) self->getItemData(i));
      }
    FXRbGcMark(self->getFont());
    }
  }


void FXRbTableItem::markfunc(FXTableItem* self){
  FXTRACE((100,"FXRbTableItem::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getIcon());
    if(self->getData())
      rb_gc_mark((VALUE) self->getData());
    }
  }


void FXRbTableItem::freefunc(FXRbTableItem* self){
  FXTRACE((100,"FXRbTableItem::markfunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbTable::markfunc(FXTable* self){
  FXTRACE((100,"FXRbTable::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    for(FXint i=0;i<self->getNumRows();i++){
      for(FXint j=0;j<self->getNumCols();j++){
        FXRbGcMark(self->getItemIcon(i,j));
        if(self->getItemData(i,j))
          rb_gc_mark((VALUE) self->getItemData(i,j));
        }
      }
    }
  }


void FXRbHeaderItem::markfunc(FXHeaderItem* self){
  FXTRACE((100,"FXRbHeaderItem::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getIcon());
    if(self->getData())
      rb_gc_mark((VALUE) self->getData());
    }
  }


void FXRbHeaderItem::freefunc(FXRbHeaderItem* self){
  FXTRACE((100,"FXRbHeaderItem::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbHeader::markfunc(FXHeader* self){
  FXTRACE((100,"FXRbHeader::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  if(self){
    for(FXint i=0;i<self->getNumItems();i++){
      FXHeaderItem* item=self->retrieveItem(i);
      FXRbGcMark(item);
      FXRbHeaderItem::markfunc(item);
      if(item->getData())
        rb_gc_mark((VALUE) item->getData());
      }
    FXRbGcMark(self->getFont());
    }
  }


void FXRbIconItem::markfunc(FXIconItem* self){
  FXTRACE((100,"FXRbIconItem::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getBigIcon());
    FXRbGcMark(self->getMiniIcon());
    if(self->getData())
      rb_gc_mark((VALUE) self->getData());
    }
  }


void FXRbIconItem::freefunc(FXRbIconItem* self){
  FXTRACE((100,"FXRbIconItem::markfunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbIconList::markfunc(FXIconList* self){
  FXTRACE((100,"%s::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    FXRbGcMark(self->getHeader());
    for(FXint i=0;i<self->getNumItems();i++){
      FXIconItem* item=self->retrieveItem(i);
      FXRbGcMark(item);
      FXRbIconItem::markfunc(item);
      if(self->getItemData(i))
        rb_gc_mark((VALUE) self->getItemData(i));
      }
    FXRbGcMark(self->getFont());
    }
  }


void FXRbDelegator::markfunc(FXDelegator* self){
  FXTRACE((100,"FXRbDelegator::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getDelegate());
    }
  }


void FXRbDebugTarget::markfunc(FXDebugTarget* self){
  FXTRACE((100,"FXRbDebugTarget::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  }


void FXRbDict::markfunc(FXDict* self){
  FXTRACE((100,"FXRbDict::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  }


void FXRbStringDict::markfunc(FXStringDict* self){
  FXTRACE((100,"FXRbStringDict::markfunc() %p\n",self));
  FXRbDict::markfunc(self);
  }


void FXRbRecentFiles::markfunc(FXRecentFiles* self){
  FXTRACE((100,"FXRbRecentFiles::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getTarget());
    }
  }


void FXRbScrollArea::markfunc(FXScrollArea* self){
  FXTRACE((100,"FXRbScrollArea::markfunc() %p\n",self));
  FXRbComposite::markfunc(self);
  if(self){
    FXRbGcMark(self->horizontalScrollbar());
    FXRbGcMark(self->verticalScrollbar());
    }
  }


void FXRbDocument::markfunc(FXDocument* self){
  FXTRACE((100,"FXRbDocument::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  }


void FXRbGLContext::markfunc(FXGLContext* self){
  FXTRACE((100,"FXRbGLContext::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    FXRbGcMark(self->getVisual());
    }
  }


void FXRbGLObject::markfunc(FXGLObject* self){
  FXTRACE((100,"FXRbGLObject::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  }


void FXRbGLObject::freefunc(FXRbGLObject* self){
  FXTRACE((100,"FXRbGLObject::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbGLGroup::markfunc(FXGLGroup* self){
  FXTRACE((100,"FXRbGLGroup::markfunc() %p\n",self));
  FXRbObject::markfunc(self);
  if(self){
    for(FXint i=0;i<self->no();i++){
      FXRbGcMark(self->child(i));
      }
    }
  }


void FXRbFont::markfunc(FXFont* self){
  FXTRACE((100,"FXRbFont::markfunc() %p\n",self));
  FXRbId::markfunc(self);
  }


void FXRbIconDict::markfunc(FXIconDict* self){
  FXTRACE((100,"FXRbIconDict::markfunc() %p\n",self));
  FXRbDict::markfunc(self);
  if(self){
    FXRbGcMark(self->getApp());
    if(self->no()>0){
      FXint pos=self->first();
      FXint last=self->last();
      while(pos<=last){
        const FXchar* name=self->key(pos);
        FXIcon* icon=self->find(name);
        FXRbGcMark(icon);
        pos=self->next(pos);
        }
      }
    }
  }


void FXRbFileDict::markfunc(FXFileDict* self){
  FXTRACE((100,"FXRbFileDict::markfunc() %p\n",self));
  FXRbDict::markfunc(self);
  if(self){
    FXRbGcMark(self->getApp());
    if(self->no()>0){
      FXint pos=self->first();
      FXint last=self->last();
      while(pos<=last){
        const FXchar* key=self->key(pos);
        FXFileAssoc* assoc=self->find(key);
        FXRbGcMark(assoc);
        pos=self->next(pos);
        }
      }
    }
  }


void FXRbDial::markfunc(FXDial* self){
  FXTRACE((100,"FXRbDial::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbDragCorner::markfunc(FXDragCorner* self){
  FXTRACE((100,"FXRbDragCorner::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  }


void FXRbDirItem::markfunc(FXDirItem* self){
  FXTRACE((100,"FXRbDirItem::markfunc() %p\n",self));
  FXRbTreeItem::markfunc(self);
  if(self){
    FXRbGcMark(self->getAssoc());
    }
  }


void FXRbDirItem::freefunc(FXRbDirItem* self){
  FXTRACE((100,"FXRbDirItem::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }

void FXRbDirList::markfunc(FXDirList* self){
  FXTRACE((100,"FXRbDirList::markfunc() %p\n",self));
  FXRbTreeList::markfunc(self);
  if(self){
    FXRbGcMark(self->getAssociations());
    }
  }


void FXRb4Splitter::markfunc(FX4Splitter* self){
  FXTRACE((100,"FXRb4Splitter::markfunc() %p\n",self));
  FXRbComposite::markfunc(self);
  if(self){
    FXRbGcMark(self->getTopLeft());
    FXRbGcMark(self->getTopRight());
    FXRbGcMark(self->getBottomLeft());
    FXRbGcMark(self->getBottomRight());
    }
  }


void FXRbFileItem::markfunc(FXFileItem* self){
  FXTRACE((100,"FXRbFileItem::markfunc() %p\n",self));
  FXRbIconItem::markfunc(self);
  if(self){
    FXRbGcMark(self->getAssoc());
    }
  }


void FXRbFileItem::freefunc(FXRbFileItem* self){
  FXTRACE((100,"FXRbFileItem::freefunc() %p\n",self));
  if(self && !self->owned) delete self;
  }


void FXRbFileList::markfunc(FXFileList* self){
  FXTRACE((100,"FXRbFileList::markfunc() %p\n",self));
  FXRbIconList::markfunc(self);
  if(self){
    FXRbGcMark(self->getAssociations());
    for(FXint i=0;i<self->getNumItems();i++){
      FXFileAssoc* assoc=self->getItemAssoc(i);
      FXRbGcMark(assoc);
      }
    }
  }


void FXRbDirBox::markfunc(FXDirBox* self){
  FXTRACE((100,"FXRbDirBox::markfunc() %p\n",self));
  FXRbTreeListBox::markfunc(self);
  }


void FXRbDriveBox::markfunc(FXDriveBox* self){
  FXTRACE((100,"FXRbDriveBox::markfunc() %p\n",self));
  FXRbListBox::markfunc(self);
  }


void FXRbDirSelector::markfunc(FXDirSelector* self){
  FXTRACE((100,"FXRbDirSelector::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->acceptButton());
    FXRbGcMark(self->cancelButton());
    }
  }


void FXRbFileSelector::markfunc(FXFileSelector* self){
  FXTRACE((100,"FXRbFileSelector::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->acceptButton());
    FXRbGcMark(self->cancelButton());
    }
  }


void FXRbFontSelector::markfunc(FXFontSelector* self){
  FXTRACE((100,"FXRbFontSelector::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->acceptButton());
    FXRbGcMark(self->cancelButton());
    }
  }


void FXRbDirDialog::markfunc(FXDirDialog* self){
  FXTRACE((100,"FXRbDirDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbFileDialog::markfunc(FXFileDialog* self){
  FXTRACE((100,"FXRbFileDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbFontDialog::markfunc(FXFontDialog* self){
  FXTRACE((100,"FXRbFontDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbListBox::markfunc(FXListBox* self){
  FXTRACE((100,"FXRbListBox::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    for(FXint i=0;i<self->getNumItems();i++){
      FXRbGcMark(self->getItemIcon(i));
      if(self->getItemData(i))
        rb_gc_mark((VALUE) self->getItemData(i));
      }
    }
  }


void FXRbTreeListBox::markfunc(FXTreeListBox* self){
  FXTRACE((100,"FXRbTreeListBox::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    for(FXTreeItem* item=self->getFirstItem();item!=0;item=item->getNext()){
      FXRbGcMark(item);
      FXRbTreeItem::markfunc(item);
      }
    }
  }


void FXRbTooltip::markfunc(FXTooltip* self){
  FXTRACE((100,"FXRbTooltip::markfunc() %p\n",self));
  FXRbShell::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbRootWindow::markfunc(FXRootWindow* self){
  FXTRACE((100,"FXRbRootWindow::markfunc() %p\n",self));
  FXRbComposite::markfunc(self);
  }


void FXRbPNGIcon::markfunc(FXPNGIcon *self){
  FXTRACE((100,"FXRbPNGIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbMDIMenu::markfunc(FXMDIMenu *self){
  FXTRACE((100,"FXRbMDIMenu::markfunc() %p\n",self));
  FXRbMenuPane::markfunc(self);
  }


void FXRbMDIRestoreButton::markfunc(FXMDIRestoreButton *self){
  FXTRACE((100,"FXRbMDIRestoreButton::markfunc() %p\n",self));
  FXRbButton::markfunc(self);
  }


void FXRbXPMImage::markfunc(FXXPMImage *self){
  FXTRACE((100,"FXRbXPMImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbJPGImage::markfunc(FXJPGImage *self){
  FXTRACE((100,"FXRbJPGImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbTextField::markfunc(FXTextField *self){
  FXTRACE((100,"FXRbTextField::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbMenuCascade::markfunc(FXMenuCascade *self){
  FXTRACE((100,"FXRbMenuCascade::markfunc() %p\n",self));
  FXRbMenuCaption::markfunc(self);
  if(self){
    FXRbGcMark(self->getMenu());
    }
  }


void FXRbMenuCommand::markfunc(FXMenuCommand *self){
  FXTRACE((100,"FXRbMenuCommand::markfunc() %p\n",self));
  FXRbMenuCaption::markfunc(self);
  }


void FXRbMenubar::markfunc(FXMenubar *self){
  FXTRACE((100,"FXRbMenubar::markfunc() %p\n",self));
  FXRbToolbar::markfunc(self);
  }


void FXRbScrollCorner::markfunc(FXScrollCorner *self){
  FXTRACE((100,"FXRbScrollCorner::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  }


void FXRbShutter::markfunc(FXShutter *self){
  FXTRACE((100,"FXRbShutter::markfunc() %p\n",self));
  FXRbVerticalFrame::markfunc(self);
  }


void FXRbProgressBar::markfunc(FXProgressBar *self){
  FXTRACE((100,"FXRbProgressBar::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbHorizontalSeparator::markfunc(FXHorizontalSeparator *self){
  FXTRACE((100,"FXRbHorizontalSeparator::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbSpinner::markfunc(FXSpinner *self){
  FXTRACE((100,"FXRbSpinner::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbGIFIcon::markfunc(FXGIFIcon *self){
  FXTRACE((100,"FXRbGIFIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbTIFIcon::markfunc(FXTIFIcon *self){
  FXTRACE((100,"FXRbTIFIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbPCXIcon::markfunc(FXPCXIcon *self){
  FXTRACE((100,"FXRbPCXIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbMDIMaximizeButton::markfunc(FXMDIMaximizeButton *self){
  FXTRACE((100,"FXRbMDIMaximizeButton::markfunc() %p\n",self));
  FXRbButton::markfunc(self);
  }


void FXRbMDIDeleteButton::markfunc(FXMDIDeleteButton *self){
  FXTRACE((100,"FXRbMDIDeleteButton::markfunc() %p\n",self));
  FXRbButton::markfunc(self);
  }


void FXRbMenuButton::markfunc(FXMenuButton *self){
  FXTRACE((100,"FXRbMenuButton::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  if(self){
    FXRbGcMark(self->getMenu());
    }
  }


void FXRbMatrix::markfunc(FXMatrix *self){
  FXTRACE((100,"FXRbMatrix::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbMenuSeparator::markfunc(FXMenuSeparator *self){
  FXTRACE((100,"FXRbMenuSeparator::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  }


void FXRbSwitcher::markfunc(FXSwitcher *self){
  FXTRACE((100,"FXRbSwitcher::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbSlider::markfunc(FXSlider *self){
  FXTRACE((100,"FXRbSlider::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbToolbarGrip::markfunc(FXToolbarGrip *self){
  FXTRACE((100,"FXRbToolbarGrip::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  }


void FXRbJPGIcon::markfunc(FXJPGIcon *self){
  FXTRACE((100,"FXRbJPGIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbTabBar::markfunc(FXTabBar *self){
  FXTRACE((100,"FXRbTabBar::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  }


void FXRbToolbarTab::markfunc(FXToolbarTab *self){
  FXTRACE((100,"FXRbToolbarTab::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbSearchDialog::markfunc(FXSearchDialog *self){
  FXTRACE((100,"FXRbSearchDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbPrintDialog::markfunc(FXPrintDialog *self){
  FXTRACE((100,"FXRbPrintDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbMDIMinimizeButton::markfunc(FXMDIMinimizeButton *self){
  FXTRACE((100,"FXRbMDIMinimizeButton::markfunc() %p\n",self));
  FXRbButton::markfunc(self);
  }


void FXRbGIFCursor::markfunc(FXGIFCursor *self){
  FXTRACE((100,"FXRbGIFCursor::markfunc() %p\n",self));
  FXRbCursor::markfunc(self);
  }


void FXRbGLViewer::markfunc(FXGLViewer *self){
  FXTRACE((100,"FXRbGLViewer::markfunc() %p\n",self));
  FXRbGLCanvas::markfunc(self);
  if(self){
    FXRbGcMark(self->getScene());
    FXRbGcMark(self->getSelection());
    }
  }


void FXRbGIFImage::markfunc(FXGIFImage *self){
  FXTRACE((100,"FXRbGIFImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbTIFImage::markfunc(FXTIFImage *self){
  FXTRACE((100,"FXRbTIFImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbPCXImage::markfunc(FXPCXImage *self){
  FXTRACE((100,"FXRbPCXImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbMenuPane::markfunc(FXMenuPane *self){
  FXTRACE((100,"FXRbMenuPane::markfunc() %p\n",self));
  FXRbPopup::markfunc(self);
  }


void FXRbSplitter::markfunc(FXSplitter *self){
  FXTRACE((100,"FXRbSplitter::markfunc() %p\n",self));
  FXRbComposite::markfunc(self);
  }


void FXRbStatusbar::markfunc(FXStatusbar *self){
  FXTRACE((100,"FXRbStatusbar::markfunc() %p\n",self));
  FXRbHorizontalFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getStatusline());
    FXRbGcMark(self->getDragCorner());
    }
  }


void FXRbMDIChild::markfunc(FXMDIChild *self){
  FXTRACE((100,"FXRbMDIChild::markfunc() %p\n",self));
  FXRbComposite::markfunc(self);
  if(self){
    FXRbGcMark(self->getMDIPrev());
    FXRbGcMark(self->getMDINext());
    FXRbGcMark(self->contentWindow());
    FXRbGcMark(self->getWindowIcon());
    FXRbGcMark(self->getWindowMenu());
    FXRbGcMark(self->getFont());
    }
  }


void FXRbPNGImage::markfunc(FXPNGImage *self){
  FXTRACE((100,"FXRbPNGImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbVisual::markfunc(FXVisual *self){
  FXTRACE((100,"FXRbVisual::markfunc() %p\n",self));
  FXRbId::markfunc(self);
  }


void FXRbVerticalSeparator::markfunc(FXVerticalSeparator *self){
  FXTRACE((100,"FXRbVerticalSeparator::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbToggleButton::markfunc(FXToggleButton *self){
  FXTRACE((100,"FXRbToggleButton::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  if(self){
    FXRbGcMark(self->getAltIcon());
    }
  }


void FXRbPopup::markfunc(FXPopup *self){
  FXTRACE((100,"FXRbPopup::markfunc() %p\n",self));
  FXRbShell::markfunc(self);
  if(self){
    FXRbGcMark(self->getGrabOwner());
    }
  }


void FXRbOptionMenu::markfunc(FXOptionMenu *self){
  FXTRACE((100,"FXRbOptionMenu::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  if(self){
    FXRbGcMark(self->getCurrent());
    FXRbGcMark(self->getPopup());
    }
  }


void FXRbMessageBox::markfunc(FXMessageBox *self){
  FXTRACE((100,"FXRbMessageBox::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbToolbar::markfunc(FXToolbar *self){
  FXTRACE((100,"FXRbToolbar::markfunc() %p\n",self));
  FXRbPacker::markfunc(self);
  if(self){
    FXRbGcMark(self->getDryDock());
    FXRbGcMark(self->getWetDock());
    }
  }


void FXRbGLCanvas::markfunc(FXGLCanvas *self){
  FXTRACE((100,"FXRbGLCanvas::markfunc() %p\n",self));
  FXRbCanvas::markfunc(self);
  }


void FXRbGLVisual::markfunc(FXGLVisual *self){
  FXTRACE((100,"FXRbGLVisual::markfunc() %p\n",self));
  FXRbVisual::markfunc(self);
  }


void FXRbOption::markfunc(FXOption *self){
  FXTRACE((100,"FXRbOption::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  }


void FXRbScrollWindow::markfunc(FXScrollWindow *self){
  FXTRACE((100,"FXRbScrollWindow::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    FXRbGcMark(self->contentWindow());
    }
  }


void FXRbText::markfunc(FXText *self){
  FXTRACE((100,"FXRbText::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbToolbarShell::markfunc(FXToolbarShell *self){
  FXTRACE((100,"FXRbToolbarShell::markfunc() %p\n",self));
  FXRbTopWindow::markfunc(self);
  }


void FXRbInputDialog::markfunc(FXInputDialog *self){
  FXTRACE((100,"FXRbInputDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbMDIClient::markfunc(FXMDIClient *self){
  FXTRACE((100,"FXRbMDIClient::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    register FXWindow *win;
    for(win=self->getMDIChildFirst(); win!=NULL; win=win->getNext()){
      FXRbGcMark(win);
      }
    }
  }


void FXRbMenuTitle::markfunc(FXMenuTitle *self){
  FXTRACE((100,"FXRbMenuTitle::markfunc() %p\n",self));
  FXRbMenuCaption::markfunc(self);
  if(self){
    FXRbGcMark(self->getMenu());
    }
  }


void FXRbImageView::markfunc(FXImageView *self){
  FXTRACE((100,"FXRbImageView::markfunc() %p\n",self));
  FXRbScrollArea::markfunc(self);
  if(self){
    FXRbGcMark(self->getImage());
    }
  }


void FXRbShutterItem::markfunc(FXShutterItem *self){
  FXTRACE((100,"FXRbShutterItem::markfunc() %p\n",self));
  FXRbVerticalFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getButton());
    FXRbGcMark(self->getContent());
    }
  }


void FXRbMDIWindowButton::markfunc(FXMDIWindowButton *self){
  FXTRACE((100,"FXRbMDIWindowButton::markfunc() %p\n",self));
  FXRbMenuButton::markfunc(self);
  }


void FXRbMenuCaption::markfunc(FXMenuCaption *self){
  FXTRACE((100,"FXRbMenuCaption::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    FXRbGcMark(self->getIcon());
    }
  }


void FXRbTabItem::markfunc(FXTabItem *self){
  FXTRACE((100,"FXRbTabItem::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  }


void FXRbStatusline::markfunc(FXStatusline *self){
  FXTRACE((100,"FXRbStatusline::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  if(self){
    FXRbGcMark(self->getFont());
    }
  }


void FXRbGLShape::markfunc(FXGLShape *self){
  FXTRACE((100,"FXRbGLShape::markfunc() %p\n",self));
  FXRbGLObject::markfunc(self);
  }


void FXRbTabBook::markfunc(FXTabBook *self){
  FXTRACE((100,"FXRbTabBook::markfunc() %p\n",self));
  FXRbTabBar::markfunc(self);
  }


void FXRbReplaceDialog::markfunc(FXReplaceDialog *self){
  FXTRACE((100,"FXRbReplaceDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbXPMIcon::markfunc(FXXPMIcon *self){
  FXTRACE((100,"FXRbXPMIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbRadioButton::markfunc(FXRadioButton *self){
  FXTRACE((100,"FXRbRadioButton::markfunc() %p\n",self));
  FXRbLabel::markfunc(self);
  }


void FXRbScrollbar::markfunc(FXScrollbar *self){
  FXTRACE((100,"FXRbScrollbar::markfunc() %p\n",self));
  FXRbWindow::markfunc(self);
  }


void FXRbStream::markfunc(FXStream *self){
  FXTRACE((100,"FXRbStream::markfunc() %p\n",self));
  if(self){
    FXRbGcMark((void*)self->container());
    }
  }


void FXRbFileStream::markfunc(FXFileStream *self){
  FXTRACE((100,"FXRbFileStream::markfunc() %p\n",self));
  FXRbStream::markfunc(self);
  }


void FXRbMemoryStream::markfunc(FXMemoryStream *self){
  FXTRACE((100,"FXRbMemoryStream::markfunc() %p\n",self));
  FXRbStream::markfunc(self);
  }


void FXRbDC::markfunc(FXDC *self){
  FXTRACE((100,"FXRbDC::markfunc() %p\n",self));
  }


void FXRbDCWindow::markfunc(FXDCWindow *self){
  FXTRACE((100,"FXRbDCWindow::markfunc() %p\n",self));
  FXRbDC::markfunc(self);
  }


void FXRbDCPrint::markfunc(FXDCPrint *self){
  FXTRACE((100,"FXRbDCPrint::markfunc() %p\n",self));
  FXRbDC::markfunc(self);
  }


void FXRbProgressDialog::markfunc(FXProgressDialog* self){
  FXTRACE((100,"FXRbProgressDialog::markfunc() %p\n",self));
  FXRbDialogBox::markfunc(self);
  }


void FXRbPicker::markfunc(FXPicker* self){
  FXTRACE((100,"FXRbPicker::markfunc() %p\n",self));
  FXRbButton::markfunc(self);
  }


void FXRbColorBar::markfunc(FXColorBar* self){
  FXTRACE((100,"FXRbColorBar::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbColorWheel::markfunc(FXColorWheel* self){
  FXTRACE((100,"FXRbColorWheel::markfunc() %p\n",self));
  FXRbFrame::markfunc(self);
  }


void FXRbICOIcon::markfunc(FXICOIcon* self){
  FXTRACE((100,"FXRbICOIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbICOImage::markfunc(FXICOImage* self){
  FXTRACE((100,"FXRbICOImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }


void FXRbTGAIcon::markfunc(FXTGAIcon* self){
  FXTRACE((100,"FXRbTGAIcon::markfunc() %p\n",self));
  FXRbIcon::markfunc(self);
  }


void FXRbTGAImage::markfunc(FXTGAImage* self){
  FXTRACE((100,"FXRbTGAImage::markfunc() %p\n",self));
  FXRbImage::markfunc(self);
  }

