require 'fox'

module Fox
  class FXFileStream
    def FXFileStream.open(filename, save_or_load, container=nil)
      fstream = FXFileStream.new(container)
      if block_given?
        if fstream.open(filename, save_or_load)
          yield fstream
          fstream.close
        else
          # open failed; raise an exception?
        end
        nil
      else
        if fstream.open(filename, save_or_load)
          fstream
        else
          # open failed; raise an exception?
        end
      end
    end
  end

  class FX_Header
    def appendItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        appendItem2(*args)
      else
        appendItem1(*args)
      end
    end
    def insertItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        insertItem2(*args)
      else
        insertItem1(*args)
      end
    end
    def prependItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        prependItem2(*args)
      else
        prependItem1(*args)
      end
    end
    def replaceItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        replaceItem2(*args)
      else
        replaceItem1(*args)
      end
    end
  end

  class FX_IconList
    def appendItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        appendItem2(*args)
      else
        appendItem1(*args)
      end
    end
    def insertItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        insertItem2(*args)
      else
        insertItem1(*args)
      end
    end
    def prependItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        prependItem2(*args)
      else
        prependItem1(*args)
      end
    end
    def replaceItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        replaceItem2(*args)
      else
        replaceItem1(*args)
      end
    end
  end

  class FX_List
    def appendItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        appendItem2(*args)
      else
        appendItem1(*args)
      end
    end
    def insertItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        insertItem2(*args)
      else
        insertItem1(*args)
      end
    end
    def prependItem(*args)
      if (args.length > 0) && (args[0].kind_of? String)
        prependItem2(*args)
      else
        prependItem1(*args)
      end
    end
    def replaceItem(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        replaceItem2(*args)
      else
        replaceItem1(*args)
      end
    end
  end

  class FXRange
    def include(*args)
      if args.length == 3
        includePoint(*args)
      else
        if args[0].kind_of? Fox::FXRange
          includeRange(*args)
        else
          includeVec(*args)
        end
      end
    end
  end

  class FX_TreeList
    def addItemAfter(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemAfter2(*args)
      else
        addItemAfter1(*args)
      end
    end
    def addItemBefore(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemBefore2(*args)
      else
        addItemBefore1(*args)
      end
    end
    def addItemFirst(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemFirst2(*args)
      else
        addItemFirst1(*args)
      end
    end
    def addItemLast(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemLast2(*args)
      else
        addItemLast1(*args)
      end
    end
  end

  class FX_TreeListBox
    def addItemAfter(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemAfter2(*args)
      else
        addItemAfter1(*args)
      end
    end
    def addItemBefore(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemBefore2(*args)
      else
        addItemBefore1(*args)
      end
    end
    def addItemFirst(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemFirst2(*args)
      else
        addItemFirst1(*args)
      end
    end
    def addItemLast(*args)
      if (args.length > 1) && (args[1].kind_of? String)
        addItemLast2(*args)
      else
        addItemLast1(*args)
      end
    end
  end
end
