/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

%{
static VALUE
_wrap_FX4Splitter_initialize1(int argc, VALUE *argv, VALUE self) {
    VALUE varg0, varg1, varg2, varg3, varg4, varg5;
    FXComposite *arg0 ;
    FXuint arg1 = FOURSPLITTER_NORMAL ;
    FXint arg2 = 0 ;
    FXint arg3 = 0 ;
    FXint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXRb4Splitter *result ;
    
    rb_scan_args(argc, argv, "15", &varg0, &varg1, &varg2, &varg3, &varg4, &varg5);
    Get_FXComposite(varg0, arg0);
    if (argc > 1) arg1 = NUM2UINT(varg1);
    if (argc > 2) arg2 = NUM2INT(varg2);
    if (argc > 3) arg3 = NUM2INT(varg3);
    if (argc > 4) arg4 = NUM2INT(varg4);
    if (argc > 5) arg5 = NUM2INT(varg5);
    result = (FXRb4Splitter *)new FXRb4Splitter(arg0,arg1,arg2,arg3,arg4,arg5);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    return self;
}

static VALUE
_wrap_FX4Splitter_initialize2(int argc, VALUE *argv, VALUE self) {
    VALUE varg0, varg1, varg2, varg3, varg4, varg5, varg6, varg7;
    FXComposite *arg0;
    FXObject *arg1;
    FXSelector arg2;
    FXuint arg3 = FOURSPLITTER_NORMAL ;
    FXint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXint arg7 = 0 ;
    FXRb4Splitter *result ;
    
    rb_scan_args(argc, argv, "35", &varg0, &varg1, &varg2, &varg3, &varg4, &varg5, &varg6, &varg7);
    Get_FXComposite(varg0, arg0);
    Get_FXObject(varg1, arg1);
    if (argc > 2) arg2 = NUM2UINT(varg2);
    if (argc > 3) arg3 = NUM2UINT(varg3);
    if (argc > 4) arg4 = NUM2INT(varg4);
    if (argc > 5) arg5 = NUM2INT(varg5);
    if (argc > 6) arg6 = NUM2INT(varg6);
    if (argc > 7) arg7 = NUM2INT(varg7);
    result = (FXRb4Splitter *)new FXRb4Splitter(arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    return self;
}

static VALUE
_wrap_FX_4Splitter_initialize1(int argc, VALUE *argv, VALUE self) {
    VALUE varg0, varg1, varg2, varg3, varg4, varg5;
    FXComposite *arg0 ;
    FXuint arg1 = FOURSPLITTER_NORMAL ;
    FXint arg2 = 0 ;
    FXint arg3 = 0 ;
    FXint arg4 = 0 ;
    FXint arg5 = 0 ;
    FX4Splitter *result ;
    
    rb_scan_args(argc, argv, "15", &varg0, &varg1, &varg2, &varg3, &varg4, &varg5);
    Get_FXComposite(varg0, arg0);
    if (argc > 1) arg1 = NUM2UINT(varg1);
    if (argc > 2) arg2 = NUM2INT(varg2);
    if (argc > 3) arg3 = NUM2INT(varg3);
    if (argc > 4) arg4 = NUM2INT(varg4);
    if (argc > 5) arg5 = NUM2INT(varg5);
    result = (FX4Splitter *)new FX4Splitter(arg0,arg1,arg2,arg3,arg4,arg5);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    return self;
}

static VALUE
_wrap_FX_4Splitter_initialize2(int argc, VALUE *argv, VALUE self) {
    VALUE varg0, varg1, varg2, varg3, varg4, varg5, varg6, varg7;
    FXComposite *arg0 ;
    FXObject *arg1;
    FXSelector arg2;
    FXuint arg3 = FOURSPLITTER_NORMAL ;
    FXint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXint arg7 = 0 ;
    FX4Splitter *result ;
    
    rb_scan_args(argc, argv, "35", &varg0, &varg1, &varg2, &varg3, &varg4, &varg5, &varg6, &varg7);
    Get_FXComposite(varg0, arg0);
    Get_FXObject(varg1, arg1);
    if (argc > 2) arg2 = NUM2UINT(varg2);
    if (argc > 3) arg3 = NUM2UINT(varg3);
    if (argc > 4) arg4 = NUM2INT(varg4);
    if (argc > 5) arg5 = NUM2INT(varg5);
    if (argc > 6) arg6 = NUM2INT(varg6);
    if (argc > 7) arg7 = NUM2INT(varg7);
    result = (FX4Splitter *)new FX4Splitter(arg0,arg1,arg2,arg3,arg4,arg5,arg6,arg7);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    return self;
}
%}

// Splitter options
enum {
  FOURSPLITTER_TRACKING = 0x00008000,	// Track continuously during split
  FOURSPLITTER_NORMAL   = 0
  };



/**
* The Four-way splitter is a layout manager which manages
* four children like four panes in a window.
* You can use a four-way splitter for example in a CAD program
* where you may want to maintain three orthographic views, and
* one oblique view of a model.
* The four-way splitter allows interactive repartitioning of the
* panes by means of moving the central splitter bars.
* When the four-way splitter is itself resized, each child is
* proportionally resized, maintaining the same split-percentage.
*/
class FX4Splitter : public FXComposite {
protected:
  FX4Splitter();
  FXuchar getMode(FXint x,FXint y);
  void moveSplit(FXint x,FXint y);
  void drawSplit(FXint x,FXint y);
  void adjustLayout();
  virtual void layout();
public:
  long onLeftBtnPress(FXObject*,FXSelector,void* PTR_EVENT);
  long onLeftBtnRelease(FXObject*,FXSelector,void* PTR_EVENT);
  long onMotion(FXObject*,FXSelector,void* PTR_EVENT);
  long onFocusUp(FXObject*,FXSelector,void* PTR_EVENT);
  long onFocusDown(FXObject*,FXSelector,void* PTR_EVENT);
  long onFocusLeft(FXObject*,FXSelector,void* PTR_EVENT);
  long onFocusRight(FXObject*,FXSelector,void* PTR_EVENT);
  long onCmdExpand(FXObject*,FXSelector,void*);
  long onUpdExpand(FXObject*,FXSelector,void*);
public:
  enum {
    ID_EXPAND_ALL=FXComposite::ID_LAST,
    ID_EXPAND_TOPLEFT,
    ID_EXPAND_TOPRIGHT,
    ID_EXPAND_BOTTOMLEFT,
    ID_EXPAND_BOTTOMRIGHT,
    ID_LAST
    };
public:

  /// Create 4-way splitter, initially shown as four unexpanded panes
  FX4Splitter(FXComposite* p,FXuint opts=FOURSPLITTER_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  /// Create 4-way splitter, initially shown as four unexpanded panes; notifies target about size changes
  // FX4Splitter(FXComposite* p,FXObject* tgt,FXSelector sel,FXuint opts=FOURSPLITTER_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  /// Get top left child, if any
  FXWindow *getTopLeft() const;

  /// Get top right child, if any
  FXWindow *getTopRight() const;

  /// Get bottom left child, if any
  FXWindow *getBottomLeft() const;

  /// Get bottom right child, if any
  FXWindow *getBottomRight() const;

  /// Get horizontal split fraction
  FXint getHSplit() const;

  /// Get vertical split fraction
  FXint getVSplit() const;

  /// Change horizontal split fraction
  void setHSplit(FXint s);

  /// Change vertical split fraction
  void setVSplit(FXint s);

  /// Return current splitter style
  FXuint getSplitterStyle() const;
  
  /// Change splitter style
  void setSplitterStyle(FXuint style);
  
  /// Change splitter bar width
  void setBarSize(FXint bs);
  
  /// Get splitter bar width
  FXint getBarSize() const;

  /// Expand child (ex=0..3), or restore to 4-way split (ex=-1)
  void setExpanded(FXint ex);
  
  /// Get expanded child, or -1 if not expanded
  FXint getExpanded() const;

public:
  %pragma(ruby) markfunc = "FXRb4Splitter::markfunc";
  };


class FXRb4Splitter : public FX4Splitter {
public:
  /// Create 4-way splitter, initially shown as four unexpanded panes
  FXRb4Splitter(FXComposite* p,FXuint opts=FOURSPLITTER_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0);
  %pragma(python) addtomethod = "__init__:FXPyRegister(self)"

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRb4Splitter::markfunc";
  };

#ifdef SWIGPYTHON
// Overloaded constructors for FX4Splitter
%inline %{
  FXPy4Splitter* Create4Splitter1(FXComposite* p,FXuint opts=FOURSPLITTER_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0){
    return new FXPy4Splitter(p,opts,x,y,w,h);
    }

  FXPy4Splitter* Create4Splitter2(FXComposite* p,FXObject* tgt,FXuint sel,FXuint opts=FOURSPLITTER_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0){
    return new FXPy4Splitter(p,tgt,sel,opts,x,y,w,h);
    }
%}
#endif
