/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

%{
static VALUE
_wrap_FX_DialogBox_initialize1(int argc, VALUE *argv, VALUE self) {
    FXApp *a;
    FXString *name;
    FXuint opts = DECOR_TITLE|DECOR_BORDER;
    FXint x = 0;
    FXint y = 0;
    FXint w = 0;
    FXint h = 0;
    FXint pl = 10;
    FXint pr = 10;
    FXint pt = 10;
    FXint pb = 10;
    FXint hs = 4;
    FXint vs = 4;
    FXDialogBox *result ;
    
    Get_FXApp(argv[0], a);
    {
        if (argv[1] == Qnil){
            name = new FXString;
        }
        else{
            name = new FXString(STR2CSTR(argv[1]));
        }
    }
    if (argc > 2) {
        opts = NUM2UINT(argv[2]);
    }
    if (argc > 3) {
        x = NUM2INT(argv[3]);
    }
    if (argc > 4) {
        y = NUM2INT(argv[4]);
    }
    if (argc > 5) {
        w = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        h = NUM2INT(argv[6]);
    }
    if (argc > 7) {
        pl = NUM2INT(argv[7]);
    }
    if (argc > 8) {
        pr = NUM2INT(argv[8]);
    }
    if (argc > 9) {
        pt = NUM2INT(argv[9]);
    }
    if (argc > 10) {
        pb = NUM2INT(argv[10]);
    }
    if (argc > 11) {
        hs = NUM2INT(argv[11]);
    }
    if (argc > 12) {
        vs = NUM2INT(argv[12]);
    }
    result = (FXDialogBox *)new FXDialogBox(a,(FXString const &)*name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete name;
    return self;
}

static VALUE
_wrap_FX_DialogBox_initialize2(int argc, VALUE *argv, VALUE self) {
    FXWindow *owner ;
    FXString *name ;
    FXuint opts = DECOR_TITLE|DECOR_BORDER ;
    FXint x = 0 ;
    FXint y = 0 ;
    FXint w = 0 ;
    FXint h = 0 ;
    FXint pl = 10;
    FXint pr = 10;
    FXint pt = 10;
    FXint pb = 10;
    FXint hs = 4 ;
    FXint vs = 4 ;
    FXDialogBox *result ;
    
    Get_FXWindow(argv[0], owner);
    {
        if (argv[1] == Qnil){
            name = new FXString;
        }
        else{
            name = new FXString(STR2CSTR(argv[1]));
        }
    }
    if (argc > 2) {
        opts = NUM2UINT(argv[2]);
    }
    if (argc > 3) {
        x = NUM2INT(argv[3]);
    }
    if (argc > 4) {
        y = NUM2INT(argv[4]);
    }
    if (argc > 5) {
        w = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        h = NUM2INT(argv[6]);
    }
    if (argc > 7) {
        pl = NUM2INT(argv[7]);
    }
    if (argc > 8) {
        pr = NUM2INT(argv[8]);
    }
    if (argc > 9) {
        pt = NUM2INT(argv[9]);
    }
    if (argc > 10) {
        pb = NUM2INT(argv[10]);
    }
    if (argc > 11) {
        hs = NUM2INT(argv[11]);
    }
    if (argc > 12) {
        vs = NUM2INT(argv[12]);
    }
    result = (FXDialogBox *)new FXDialogBox(owner,(FXString const &)*name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete name;
    return self;
}

static VALUE
_wrap_FXDialogBox_initialize1(int argc, VALUE *argv, VALUE self) {
    FXApp *app ;
    FXString *name ;
    FXuint opts = DECOR_TITLE|DECOR_BORDER ;
    FXint x = 0 ;
    FXint y = 0 ;
    FXint w = 0 ;
    FXint h = 0 ;
    FXint pl = 10;
    FXint pr = 10;
    FXint pt = 10;
    FXint pb = 10;
    FXint hs = 4 ;
    FXint vs = 4 ;
    FXRbDialogBox *result ;
    
    Get_FXApp(argv[0], app);
    {
        if (argv[1] == Qnil){
            name = new FXString;
        }
        else{
            name = new FXString(STR2CSTR(argv[1]));
        }
    }
    if (argc > 2) {
        opts = NUM2UINT(argv[2]);
    }
    if (argc > 3) {
        x = NUM2INT(argv[3]);
    }
    if (argc > 4) {
        y = NUM2INT(argv[4]);
    }
    if (argc > 5) {
        w = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        h = NUM2INT(argv[6]);
    }
    if (argc > 7) {
        pl = NUM2INT(argv[7]);
    }
    if (argc > 8) {
        pr = NUM2INT(argv[8]);
    }
    if (argc > 9) {
        pt = NUM2INT(argv[9]);
    }
    if (argc > 10) {
        pb = NUM2INT(argv[10]);
    }
    if (argc > 11) {
        hs = NUM2INT(argv[11]);
    }
    if (argc > 12) {
        vs = NUM2INT(argv[12]);
    }
    result = (FXRbDialogBox *)new FXRbDialogBox(app,(FXString const &)*name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete name;
    return self;
}

static VALUE
_wrap_FXDialogBox_initialize2(int argc, VALUE *argv, VALUE self) {
    FXWindow *owner ;
    FXString *name ;
    FXuint opts = DECOR_TITLE|DECOR_BORDER ;
    FXint x = 0 ;
    FXint y = 0 ;
    FXint w = 0 ;
    FXint h = 0 ;
    FXint pl = 10;
    FXint pr = 10;
    FXint pt = 10;
    FXint pb = 10;
    FXint hs = 4 ;
    FXint vs = 4 ;
    FXRbDialogBox *result ;
    
    Get_FXWindow(argv[0], owner);
    {
        if (argv[1] == Qnil){
            name = new FXString;
        }
        else{
            name = new FXString(STR2CSTR(argv[1]));
        }
    }
    if (argc > 2) {
        opts = NUM2UINT(argv[2]);
    }
    if (argc > 3) {
        x = NUM2INT(argv[3]);
    }
    if (argc > 4) {
        y = NUM2INT(argv[4]);
    }
    if (argc > 5) {
        w = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        h = NUM2INT(argv[6]);
    }
    if (argc > 7) {
        pl = NUM2INT(argv[7]);
    }
    if (argc > 8) {
        pr = NUM2INT(argv[8]);
    }
    if (argc > 9) {
        pt = NUM2INT(argv[9]);
    }
    if (argc > 10) {
        pb = NUM2INT(argv[10]);
    }
    if (argc > 11) {
        hs = NUM2INT(argv[11]);
    }
    if (argc > 12) {
        vs = NUM2INT(argv[12]);
    }
    result = new FXRbDialogBox(owner,(FXString const &)*name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete name;
    return self;
}
%}

/**
* DialogBox window.
* When receiving ID_CANCEL or ID_ACCEPT, the DialogBox breaks out of the 
* modal loop and returns FALSE or TRUE, respectively.
* To close the DialogBox when not running modally, simply send it ID_HIDE.
*/
class FXDialogBox : public FXTopWindow {
protected:
  FXDialogBox(){}
public:
  long onKeyPress(FXObject*,FXSelector,void* PTR_EVENT);
  long onKeyRelease(FXObject*,FXSelector,void* PTR_EVENT);
  long onClose(FXObject*,FXSelector,void* PTR_IGNORE);
  long onCmdAccept(FXObject*,FXSelector,void* PTR_IGNORE);
  long onCmdCancel(FXObject*,FXSelector,void* PTR_IGNORE);
public:
  enum {
    ID_CANCEL=FXTopWindow::ID_LAST,     /// Closes the dialog, cancel the entry
    ID_ACCEPT,                          /// Closes the dialog, accept the entry
    ID_LAST
    };
public:

  /// Construct free-floating dialog
  FXDialogBox(FXApp* a,const FXString& name,FXuint opts=DECOR_TITLE|DECOR_BORDER,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=10,FXint pr=10,FXint pt=10,FXint pb=10,FXint hs=4,FXint vs=4);

  /// Construct dialog which will always float over the owner window
  // FXDialogBox(FXWindow* owner,const FXString& name,FXuint opts=DECOR_TITLE|DECOR_BORDER,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=10,FXint pr=10,FXint pt=10,FXint pb=10,FXint hs=4,FXint vs=4); OVERLOAD

  /// Run modal invocation of the dialog
  virtual FXuint execute(FXuint placement=PLACEMENT_CURSOR);

public:
  %pragma(ruby) markfunc = "FXRbDialogBox::markfunc";
  };


class FXRbDialogBox : public FXDialogBox {
public:
  // Construct free-floating dialog
  FXRbDialogBox(FXApp* a,const FXString& name,FXuint opts=DECOR_TITLE|DECOR_BORDER,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=10,FXint pr=10,FXint pt=10,FXint pb=10,FXint hs=4,FXint vs=4);

  // Destructor
  virtual ~FXRbDialogBox();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS
  DECLARE_FXTOPWINDOW_VIRTUALS
  DECLARE_FXDIALOGBOX_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbDialogBox::markfunc";
  };

#ifdef SWIGPYTHON

%inline %{
  FXPyDialogBox* CreateOwnedDialogBox(FXWindow* owner,const FXString& name,FXuint opts=DECOR_TITLE|DECOR_BORDER,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=10,FXint pr=10,FXint pt=10,FXint pb=10,FXint hs=4,FXint vs=4) {
    return new FXPyDialogBox(owner,name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
  }

  FXPyDialogBox* CreateFreeDialogBox(FXApp* app,const FXString& name,FXuint opts=DECOR_TITLE|DECOR_BORDER,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=10,FXint pr=10,FXint pt=10,FXint pb=10,FXint hs=4,FXint vs=4) {
    return new FXPyDialogBox(app,name,opts,x,y,w,h,pl,pr,pt,pb,hs,vs);
  }
%}

#endif
