/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

class FXApp;


/// Encapsulates server side resource
class FXId : public FXObject {
protected:
  FXID   xid;
protected:
  // FXId():app((FXApp*)-1),xid(0){}
  FXId(FXApp* a):app(a),xid(0){}
public:

  /// Get application
  FXApp* getApp() const;

  /// Get XID handle
  // FXID id() const { return xid; } FIXME

  /// Create resource
  virtual void create();

  /// Detach resource
  virtual void detach();

  /// Destroy resource
  virtual void destroy();

  %addmethods {
    /// Set user data pointer
    void setUserData(VALUE ptr){
      self->setUserData((void*) ptr);
      }

    /// Get user data pointer
    VALUE getUserData() const {
      return self->getUserData() ? (VALUE) self->getUserData() : Qnil;
      }
  }

  /// Save object to stream
  virtual void save(FXStream& store) const;

  /// Load object from stream
  virtual void load(FXStream& store);

  /// Destructor
  virtual ~FXId();

public:
  %pragma(ruby) markfunc = "FXRbId::markfunc";
  };


class FXRbId : public FXId {
protected:
  // FXRbId():app((FXApp*)-1),xid(0){}
  FXRbId(FXApp* a):app(a),xid(0){}

  // Destructor
  virtual ~FXRbId();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbId::markfunc";
  };

