/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

class FXIcon;


/// MDI Delete button
class FXMDIDeleteButton : public FXButton {
protected:
  FXMDIDeleteButton(){}
public:
  long onPaint(FXObject*,FXSelector,void* PTR_EVENT);
public:
  /// Constructor
  FXMDIDeleteButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

public:
  %pragma(ruby) markfunc = "FXRbMDIDeleteButton::markfunc";
  };


class FXRbMDIDeleteButton : public FXMDIDeleteButton {
public:
  // Constructor
  FXRbMDIDeleteButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbMDIDeleteButton();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIDeleteButton::markfunc";
  };


/// MDI Restore button
class FXMDIRestoreButton : public FXButton {
protected:
  FXMDIRestoreButton(){}
public:
  long onPaint(FXObject*,FXSelector,void* PTR_EVENT);
public:
  /// Constructor
  FXMDIRestoreButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

public:
  %pragma(ruby) markfunc = "FXRbMDIRestoreButton::markfunc";
  };


class FXRbMDIRestoreButton : public FXMDIRestoreButton {
public:
  // Constructor
  FXRbMDIRestoreButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbMDIRestoreButton();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIRestoreButton::markfunc";
  };


/// MDI Maximize button
class FXMDIMaximizeButton : public FXButton {
protected:
  FXMDIMaximizeButton(){}
public:
  long onPaint(FXObject*,FXSelector,void* PTR_EVENT);
public:
  /// Constructor
  FXMDIMaximizeButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

public:
  %pragma(ruby) markfunc = "FXRbMDIMaximizeButton::markfunc";
  };


class FXRbMDIMaximizeButton : public FXMDIMaximizeButton {
public:
  // Constructor
  FXRbMDIMaximizeButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbMDIMaximizeButton();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIMaximizeButton::markfunc";
  };


/// MDI Minimize button
class FXMDIMinimizeButton : public FXButton {
protected:
  FXMDIMinimizeButton(){}
public:
  long onPaint(FXObject*,FXSelector,void* PTR_EVENT);
public:
  /// Constructor
  FXMDIMinimizeButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

public:
  %pragma(ruby) markfunc = "FXRbMDIMinimizeButton::markfunc";
  };


class FXRbMDIMinimizeButton : public FXMDIMinimizeButton {
public:
  // Constructor
  FXRbMDIMinimizeButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=FRAME_RAISED,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbMDIMinimizeButton();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIMinimizeButton::markfunc";
  };


/// MDI Window button
class FXMDIWindowButton : public FXMenuButton {
protected:
  FXMDIWindowButton(){}
public:
  long onPaint(FXObject*,FXSelector,void* PTR_EVENT);
public:
  /// Constructor
  FXMDIWindowButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

public:
  %pragma(ruby) markfunc = "FXRbMDIWindowButton::markfunc";
  };


class FXRbMDIWindowButton : public FXMDIWindowButton {
public:
  // Constructor
  FXRbMDIWindowButton(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbMDIWindowButton();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIWindowButton::markfunc";
  };


/// MDI Window Menu
class FXMDIMenu : public FXMenuPane {
protected:
  FXMDIMenu(){}
public:

  /// Construct MDI menu
  FXMDIMenu(FXWindow *owner,FXObject* tgt=NULL);

  /// Destructor
  virtual ~FXMDIMenu();

public:
  %pragma(ruby) markfunc = "FXRbMDIMenu::markfunc";
  };


class FXRbMDIMenu : public FXMDIMenu {
public:
  // Constructor
  FXRbMDIMenu(FXWindow *owner,FXObject* tgt=NULL);

  // Destructor
  virtual ~FXRbMDIMenu();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS
  DECLARE_FXPOPUP_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMDIMenu::markfunc";
  };

