/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

%{
static VALUE
_wrap_FX_MessageBox_initialize1(int argc, VALUE *argv, VALUE self) {
    FXApp *arg0 ;
    FXString *arg1 ;
    FXString *arg2 ;
    FXIcon *arg3 = 0 ;
    FXuint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXMessageBox *result ;
    
    Get_FXApp(argv[0], arg0);
    {
        if (argv[1] != Qnil) {
            Check_Type(argv[1], T_STRING);
            arg1 = new FXString(STR2CSTR(argv[1]));
        }else {
            arg1 = new FXString;
        }
    }
    {
        if (argv[2] != Qnil) {
            Check_Type(argv[2], T_STRING);
            arg2 = new FXString(STR2CSTR(argv[2]));
        }else {
            arg2 = new FXString;
        }
    }
    if (argc > 3) {
        Get_FXIcon(argv[3], arg3);
    }
    if (argc > 4) {
        arg4 = NUM2UINT(argv[4]);
    }
    if (argc > 5) {
        arg5 = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        arg6 = NUM2INT(argv[6]);
    }
    result = new FXMessageBox(arg0,*arg1,*arg2,arg3,arg4,arg5,arg6);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete arg1;
    delete arg2;
    return self;
}

static VALUE
_wrap_FX_MessageBox_initialize2(int argc, VALUE *argv, VALUE self) {
    FXWindow *arg0 ;
    FXString *arg1 ;
    FXString *arg2 ;
    FXIcon *arg3 = 0 ;
    FXuint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXMessageBox *result ;
    
    Get_FXWindow(argv[0], arg0);
    {
        if (argv[1] != Qnil) {
            Check_Type(argv[1], T_STRING);
            arg1 = new FXString(STR2CSTR(argv[1]));
        }else {
            arg1 = new FXString;
        }
    }
    {
        if (argv[2] != Qnil) {
            Check_Type(argv[2], T_STRING);
            arg2 = new FXString(STR2CSTR(argv[2]));
        }else {
            arg2 = new FXString;
        }
    }
    if (argc > 3) {
        Get_FXIcon(argv[3], arg3);
    }
    if (argc > 4) {
        arg4 = NUM2UINT(argv[4]);
    }
    if (argc > 5) {
        arg5 = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        arg6 = NUM2INT(argv[6]);
    }
    result = new FXMessageBox(arg0,*arg1,*arg2,arg3,arg4,arg5,arg6);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete arg1;
    delete arg2;
    return self;
}

static VALUE
_wrap_FXMessageBox_initialize1(int argc, VALUE *argv, VALUE self) {
    FXApp *arg0 ;
    FXString *arg1 ;
    FXString *arg2 ;
    FXIcon *arg3 = 0 ;
    FXuint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXRbMessageBox *result ;
    
    Get_FXApp(argv[0], arg0);
    {
        if (argv[1] != Qnil) {
            Check_Type(argv[1], T_STRING);
            arg1 = new FXString(STR2CSTR(argv[1]));
        }else {
            arg1 = new FXString;
        }
    }
    {
        if (argv[2] != Qnil) {
            Check_Type(argv[2], T_STRING);
            arg2 = new FXString(STR2CSTR(argv[2]));
        }else {
            arg2 = new FXString;
        }
    }
    if (argc > 3) {
        Get_FXIcon(argv[3], arg3);
    }
    if (argc > 4) {
        arg4 = NUM2UINT(argv[4]);
    }
    if (argc > 5) {
        arg5 = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        arg6 = NUM2INT(argv[6]);
    }
    result = new FXRbMessageBox(arg0,*arg1,*arg2,arg3,arg4,arg5,arg6);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete arg1;
    delete arg2;
    return self;
}

static VALUE
_wrap_FXMessageBox_initialize2(int argc, VALUE *argv, VALUE self) {
    FXWindow *arg0 ;
    FXString *arg1 ;
    FXString *arg2 ;
    FXIcon *arg3 = 0 ;
    FXuint arg4 = 0 ;
    FXint arg5 = 0 ;
    FXint arg6 = 0 ;
    FXRbMessageBox *result ;
    
    Get_FXWindow(argv[0], arg0);
    {
        if (argv[1] != Qnil) {
            Check_Type(argv[1], T_STRING);
            arg1 = new FXString(STR2CSTR(argv[1]));
        }else {
            arg1 = new FXString;
        }
    }
    {
        if (argv[2] != Qnil) {
            Check_Type(argv[2], T_STRING);
            arg2 = new FXString(STR2CSTR(argv[2]));
        }else {
            arg2 = new FXString;
        }
    }
    if (argc > 3) {
        Get_FXIcon(argv[3], arg3);
    }
    if (argc > 4) {
        arg4 = NUM2UINT(argv[4]);
    }
    if (argc > 5) {
        arg5 = NUM2INT(argv[5]);
    }
    if (argc > 6) {
        arg6 = NUM2INT(argv[6]);
    }
    result = new FXRbMessageBox(arg0,*arg1,*arg2,arg3,arg4,arg5,arg6);
    DATA_PTR(self) = result;
    FXRbRegisterRubyObj(self, result);
    delete arg1;
    delete arg2;
    return self;
}
%}

// Message box buttons
enum {
  MBOX_OK               = 0x10000000,   /// Message box has a only an OK button
  MBOX_OK_CANCEL        = 0x20000000,   /// Message box has OK and CANCEL buttons
  MBOX_YES_NO           = 0x30000000,   /// Message box has YES and NO buttons
  MBOX_YES_NO_CANCEL    = 0x40000000,   /// Message box has YES, NO, and CANCEL buttons
  MBOX_QUIT_CANCEL      = 0x50000000,   /// Message box has QUIT and CANCEL buttons
  MBOX_QUIT_SAVE_CANCEL = 0x60000000    /// Message box has QUIT, SAVE, and CANCEL buttons
  };


// Return values
enum {
  MBOX_CLICKED_YES      = 1,            /// The YES button was clicked
  MBOX_CLICKED_NO       = 2,            /// The NO button was clicked
  MBOX_CLICKED_OK       = 3,            /// The OK button was clicked
  MBOX_CLICKED_CANCEL   = 4,            /// The CANCEL button was clicked
  MBOX_CLICKED_QUIT     = 5,            /// The QUIT button was clicked
  MBOX_CLICKED_SAVE     = 6             /// The SAVE button was clicked
  };


/// Message box
class FXMessageBox : public FXDialogBox {
protected:
  FXMessageBox(){}
public:
  long onCmdClicked(FXObject*,FXSelector,void* PTR_IGNORE);
  long onCmdCancel(FXObject*,FXSelector,void* PTR_IGNORE);
public:
  enum{
    ID_CLICKED_YES=FXDialogBox::ID_LAST,
    ID_CLICKED_NO,
    ID_CLICKED_OK,
    ID_CLICKED_CANCEL,
    ID_CLICKED_QUIT,
    ID_CLICKED_SAVE,
    ID_LAST
    };
public:

  /// Construct message box with given caption, icon, and message text
  // FXMessageBox(FXWindow* owner,const FXString& caption,const FXString& text,FXIcon* ic=NULL,FXuint opts=0,FXint x=0,FXint y=0);

  /// Construct free floating message box with given caption, icon, and message text
  FXMessageBox(FXApp* a,const FXString& caption,const FXString& text,FXIcon* ic=NULL,FXuint opts=0,FXint x=0,FXint y=0);

#ifdef SWIGRUBY
  /// Show a modal error message
  static FXuint error(FXWindow* owner,FXuint opts,const char* caption,const char* message);

  /// Show a modal warning message
  static FXuint warning(FXWindow* owner,FXuint opts,const char* caption,const char* message);

  /// Show a modal question dialog
  static FXuint question(FXWindow* owner,FXuint opts,const char* caption,const char* message);

  /// Show a modal information dialog
  static FXuint information(FXWindow* owner,FXuint opts,const char* caption,const char* message);
#endif

public:
  %pragma(ruby) markfunc = "FXRbMessageBox::markfunc";
  };

#ifdef SWIGPYTHON

%inline %{
  // Show a modal error message
  FXuint showModalErrorBox(FXWindow* owner,FXuint opts,const char* caption,const char* message){
    return FXMessageBox::error(owner,opts,caption,message);
    }

  // Show a modal warning message
  FXuint showModalWarningBox(FXWindow* owner,FXuint opts,const char* caption,const char* message){
    return FXMessageBox::warning(owner,opts,caption,message);
    }

  // Show a modal question dialog
  FXuint showModalQuestionBox(FXWindow* owner,FXuint opts,const char* caption,const char* message){
    return FXMessageBox::question(owner,opts,caption,message);
    }

  // Show a modal information dialog
  FXuint showModalInformationBox(FXWindow* owner,FXuint opts,const char* caption,const char* message){
    return FXMessageBox::information(owner,opts,caption,message);
    }
%}

#endif


class FXRbMessageBox : public FXMessageBox {
public:
  // Construct message box with given caption, icon, and message text
  // FXRbMessageBox(FXWindow* owner,const FXString& caption,const FXString& text,FXIcon* ic=NULL,FXuint opts=0,FXint x=0,FXint y=0);
  // %pragma(python) addtomethod = "__init__:FXPyRegister(self)"

  /// Construct free floating message box with given caption, icon, and message text
  FXRbMessageBox(FXApp* a,const FXString& caption,const FXString& text,FXIcon* ic=NULL,FXuint opts=0,FXint x=0,FXint y=0);

  // Destructor
  virtual ~FXRbMessageBox();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS
  DECLARE_FXTOPWINDOW_VIRTUALS
  DECLARE_FXDIALOGBOX_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbMessageBox::markfunc";
  };

