/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

// Minimum and maximum keys
#define MINKEY    0
#define MAXKEY    65535


// Minimum and maximum types
#define MINTYPE   0
#define MAXTYPE   65535


// Association key
typedef FXuint FXSelector;


/// Base of all FOX objects
class FXObject {
public:
  /// Handle is actually declared (hidden) in FXDECLARE
  virtual long handle(FXObject* sender,FXSelector sel,void* PTR_MAGIC);

  /// Called for unhandled messages
  virtual long onDefault(FXObject*,FXSelector,void* PTR_IGNORE); // FIXME

public:

  /// Get class name of some object
  const FXchar* getClassName() const;

  /// Check if object is member of metaclass
  // FXbool isMemberOf(const FXMetaClass* metaclass) const;

  /// Save object to stream
  virtual void save(FXStream& store) const;

  /// Load object from stream
  virtual void load(FXStream& store);

  /// Virtual destructor
  virtual ~FXObject();

public:
  %pragma(ruby) markfunc = "FXRbObject::markfunc";
  };


class FXRbObject : public FXObject {
public:
  // Constructor
  FXRbObject();

  // Destructor
  virtual ~FXRbObject();

public:
  DECLARE_FXOBJECT_VIRTUALS

public:
  %pragma(ruby) markfunc = "FXRbObject::markfunc";
  };

