/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

// Typedefs from Scintilla.h
typedef unsigned long	uptr_t;
typedef long		sptr_t;

class FXScintilla : public FXScrollArea {
public:
  enum{
    ID_TICK,
    };
public:
  long onScintillaCommand(FXObject*, FXSelector, void* PTR_IGNORE);
  long onPaint(FXObject*, FXSelector, void* PTR_EVENT);
  long onConfigure(FXObject*, FXSelector, void* PTR_EVENT);
  long onTimeoutTicking(FXObject*, FXSelector, void* PTR_IGNORE);
  long onFocusIn(FXObject*, FXSelector, void* PTR_EVENT);
  long onFocusOut(FXObject*, FXSelector, void* PTR_EVENT);
  long onMotion(FXObject*, FXSelector, void* PTR_EVENT);
  long onLeftBtnPress(FXObject*, FXSelector, void* PTR_EVENT);
  long onLeftBtnRelease(FXObject*, FXSelector, void* PTR_EVENT);
  long onRightBtnPress(FXObject*, FXSelector, void* PTR_EVENT);
  long onMiddleBtnPress(FXObject*, FXSelector, void* PTR_EVENT);
  long onBeginDrag(FXObject*, FXSelector, void* PTR_EVENT);
  long onDragged(FXObject*, FXSelector, void* PTR_EVENT);
  long onEndDrag(FXObject*, FXSelector, void* PTR_EVENT);
  long onDNDEnter(FXObject*, FXSelector, void* PTR_EVENT);
  long onDNDLeave(FXObject*, FXSelector, void* PTR_EVENT);
  long onDNDMotion(FXObject*, FXSelector, void* PTR_EVENT);
  long onDNDDrop(FXObject*, FXSelector, void* PTR_EVENT);
  long onDNDRequest(FXObject*, FXSelector, void* PTR_EVENT);
  long onSelectionLost(FXObject*, FXSelector, void* PTR_EVENT);
  long onSelectionRequest(FXObject*, FXSelector, void* PTR_EVENT);
  long onClipboardLost(FXObject*, FXSelector, void* PTR_EVENT);
  long onClipboardRequest(FXObject*, FXSelector, void* PTR_EVENT);
  long onKeyPress(FXObject*, FXSelector, void* PTR_EVENT);
public:
  /// Constructor
  FXScintilla(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  /// Scintilla messaging
  void setScintillaID(int id);
  sptr_t sendMessage(unsigned int iMessage, uptr_t wParam = 0, sptr_t lParam = 0);

  // Convenience functions
  %addmethods {
    void setText(const FXString& text){
      self->sendMessage(SCI_SETTEXT,0,(sptr_t)text.text());
      }
    void addText(const FXString& text){
      self->sendMessage(SCI_ADDTEXT,text.length(),(sptr_t)text.text());
      }
  }

  /// Destructor
  virtual ~FXScintilla();
  };


class FXRbScintilla : public FXScintilla {
public:
  /// Constructor
  FXRbScintilla(FXComposite* p,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0,FXint x=0,FXint y=0,FXint w=0,FXint h=0);

  // Destructor
  virtual ~FXRbScintilla();

public:
  DECLARE_FXOBJECT_VIRTUALS
  DECLARE_FXID_VIRTUALS
  DECLARE_FXDRAWABLE_VIRTUALS
  DECLARE_FXWINDOW_VIRTUALS
  DECLARE_FXSCROLLAREA_VIRTUALS
  };
