/***********************************************************************
 * FXRuby -- the Ruby language bindings for the FOX GUI toolkit.
 * Copyright (c) 2001 by J. Lyle Johnson. All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For further information please contact the author by e-mail
 * at "lyle@users.sourceforge.net".
 ***********************************************************************/

/***********************************************************************
 * $Id: core.i,v 1.21 2002/01/21 20:14:08 ljohnson Exp $
 ***********************************************************************/

%module core

%{
#include "FXRbCommon.h"
%}

%include typemaps.i
%include renames.i
%include stubs.i

%inline %{
void setIgnoreExceptions(VALUE ignore){
  extern FXbool FXRbCatchExceptions;
  FXRbCatchExceptions=(ignore==Qtrue)? TRUE : FALSE;
  }
%}

%include fxdefs.i

%include FXStream.i
%include FXSize.i
%include FXPoint.i
%include FXRectangle.i
%include FXObject.i
%include FXDelegator.i
%include FXDict.i
%include FXStringDict.i
%include FXSettings.i
%include FXRegistry.i
%include FXAccelTable.i
%include FXRecentFiles.i
%include FXApp.i
%include FXId.i
%include FXVisual.i
%include FXFont.i
%include FXCursor.i
%include FXGIFCursor.i
%include FXDrawable.i
%include FXRegion.i
%include FXDC.i
%include FXDCWindow.i
%include FXDCPrint.i
%include FXFileDict.i
%include FXWindow.i
%include FXFrame.i
%include FXSeparator.i
%include FXLabel.i
%include FXDial.i
%include FXColorBar.i
%include FXColorWell.i
%include FXColorWheel.i
%include FXTextField.i
%include FXButton.i
%include FXPicker.i
%include FXToggleButton.i
%include FXCheckButton.i
%include FXRadioButton.i
%include FXArrowButton.i
%include FXMenuButton.i
%include FXComposite.i
%include FXPacker.i
%include FXHorizontalFrame.i
%include FXVerticalFrame.i
%include FXMatrix.i
%include FXSpinner.i
%include FXRootWindow.i
%include FXCanvas.i
%include FXGroupBox.i
%include FXShell.i
%include FXTooltip.i
%include FXPopup.i
%include FXTopWindow.i
%include FXDialogBox.i
%include FXMainWindow.i
%include FXMenuPane.i
%include FXMenuCaption.i
%include FXMenuSeparator.i
%include FXMenuTitle.i
%include FXMenuCascade.i
%include FXMenuCommand.i
%include FXToolbar.i
%include FXMenubar.i
%include FXOptionMenu.i
%include FXSwitcher.i
%include FXTabBar.i
%include FXTabBook.i
%include FXTabItem.i
%include FXScrollbar.i
%include FXScrollArea.i
%include FXScrollWindow.i
%include FXList.i
%include FXComboBox.i
%include FXListBox.i
%include FXTreeList.i
%include FXTreeListBox.i
%include FXImageView.i
%include FXTable.i
%include FXDragCorner.i
%include FXStatusbar.i
%include FXStatusline.i
%include FXMessageBox.i
%include FXDirList.i
%include FXSlider.i
%include FXSplitter.i
%include FX4Splitter.i
%include FXHeader.i
%include FXShutter.i
%include FXIconList.i
%include FXFileList.i
%include FXDirBox.i
%include FXDriveBox.i
%include FXDirSelector.i
%include FXFileSelector.i
%include FXColorSelector.i
%include FXFontSelector.i
%include FXText.i
%include FXDataTarget.i
%include FXProgressBar.i
%include FXToolbarGrip.i
%include FXToolbarShell.i
%include FXToolbarTab.i
%include FXDebugTarget.i
