require 'Lapidary/TestCase'

require 'fox'

include Fox

class TestFXRectangle < Lapidary::TestCase
  def setup
    @rect1 = FXRectangle.new
    @rect2 = FXRectangle.new(5, 5, 300, 200)
    @rect3 = FXRectangle.new(FXPoint.new(5, 5), FXSize.new(300, 200))
    @rect4 = FXRectangle.new(FXPoint.new(5, 5), FXPoint.new(304, 204))
  end

  def test_equals
    r1 = FXRectangle.new
    r1.x = 10
    r1.y = 15
    r1.w = 20
    r1.h = 25
    @rect1.x = r1.x
    @rect1.y = r1.y
    @rect1.w = r1.w
    @rect1.h = r1.h
    assertEqual(@rect1, r1)
    assertEqual(@rect2, FXRectangle.new(5, 5, 300, 200))
    assertEqual(@rect3, FXRectangle.new(FXPoint.new(5, 5), FXSize.new(300, 200)))
    assertEqual(@rect4, FXRectangle.new(FXPoint.new(5, 5), FXPoint.new(304, 204)))
  end

  def test_contains
    assert(@rect2.contains(100, 100))
    assert(@rect2.contains(FXPoint.new(100, 100)))
    assert(@rect2.contains(FXRectangle.new(10, 10, 10, 10)))
  end

  def test_overlaps
    assert(@rect2.overlaps?(@rect3))
    assert(@rect2.overlaps?(FXRectangle.new(200, 2, 400, 50)))
    assert(!@rect2.overlaps?(FXRectangle.new(2, 2, 2, 2)))
  end

  def test_move
    x = @rect2.x
    y = @rect2.y
    @rect2.move(10, 10)
    assertEqual(@rect2.x, x + 10)
    assertEqual(@rect2.y, y + 10)
  end

  def test_grow
    @rect2.grow(3)
    @rect3.grow(3, 3)
    @rect4.grow(3, 3, 3, 3)
    assertEqual(@rect2, @rect3)
    assertEqual(@rect2, @rect4)
    assertEqual(@rect3, @rect4)
  end

  def test_shrink
    @rect2.grow(3)
    @rect3.grow(3, 3)
    @rect4.grow(3, 3, 3, 3)
    assertEqual(@rect2, @rect3)
    assertEqual(@rect2, @rect4)
    assertEqual(@rect3, @rect4)
  end

  def test_corners
    assertEqual(FXPoint.new(  5,   5), @rect2.tl)
    assertEqual(FXPoint.new(304,   5), @rect2.tr)
    assertEqual(FXPoint.new(  5, 204), @rect2.bl)
    assertEqual(FXPoint.new(304, 204), @rect2.br)
  end

  def test_union
  end

  def test_intersection
  end
end

if __FILE__ == $0
  require 'Lapidary/UI/Console/TestRunner'
  Lapidary::UI::Console::TestRunner.run(TestFXRectangle)
end
