require 'Lapidary/TestCase'

require 'fox'

include Fox

class TestFXSize < Lapidary::TestCase
  def setup
    @size1 = FXSize.new
    @size2 = FXSize.new(300, 200)
  end

  def test_clone
    assertEqual(@size1, @size1.clone)
    assertEqual(@size2, @size2.clone)
  end

  def test_equals
    @size1.w = 250
    @size1.h = 475
    sameSize1 = FXSize.new
    sameSize1.w = 250
    sameSize1.h = 475
    assertEqual(@size1, sameSize1)
    assertEqual(sameSize1, @size1)

    sameSize2 = FXSize.new(300, 200)
    assertEqual(@size2, sameSize2)
    assertEqual(sameSize2, @size2)
  end

  def test_uminus
    size1 = -(@size1)
    assert(size1.w == -(@size1.w) && size1.h == -(@size1.h))
    size2 = -(@size2)
    assert(size2.w == -(@size2.w) && size2.h == -(@size2.h))
  end

  def test_add
    assertEqual(FXSize.new(1, 2) + FXSize.new(3, 4), FXSize.new(4, 6))
  end

  def test_sub
    assertEqual(FXSize.new(4, 6) - FXSize.new(3, 4), FXSize.new(1, 2))
  end

  def test_mul
    assertEqual(FXSize.new(1, 2)*3, FXSize.new(3, 6))
  end

  def test_div
    assertEqual(FXSize.new(3, 6)/3, FXSize.new(1, 2))
  end
end

if __FILE__ == $0
  require 'Lapidary/UI/Console/TestRunner'
  Lapidary::UI::Console::TestRunner.run(TestFXSize)
end
